/* bubble.c generated by valac 0.54.6, the Vala compiler
 * generated from bubble.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2021 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>

#define CONFIG_ICON_NAME "com.github.ztefn.haguichi"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BUBBLE (bubble_get_type ())
#define BUBBLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BUBBLE, Bubble))
#define BUBBLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BUBBLE, BubbleClass))
#define IS_BUBBLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BUBBLE))
#define IS_BUBBLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BUBBLE))
#define BUBBLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BUBBLE, BubbleClass))

typedef struct _Bubble Bubble;
typedef struct _BubbleClass BubbleClass;
typedef struct _BubblePrivate BubblePrivate;
enum  {
	BUBBLE_0_PROPERTY,
	BUBBLE_NUM_PROPERTIES
};
static GParamSpec* bubble_properties[BUBBLE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _Bubble {
	GObject parent_instance;
	BubblePrivate * priv;
};

struct _BubbleClass {
	GObjectClass parent_class;
};

struct _BubblePrivate {
	GNotification* notification;
};

static gint Bubble_private_offset;
static gpointer bubble_parent_class = NULL;
VALA_EXTERN gchar* haguichi_current_desktop;
VALA_EXTERN GtkApplication* haguichi_app;
VALA_EXTERN gchar* text_reconnect_label;
VALA_EXTERN gchar* text_approve_label;
VALA_EXTERN gchar* text_reject_label;

VALA_EXTERN GType bubble_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bubble, g_object_unref)
VALA_EXTERN Bubble* bubble_new (const gchar* summary,
                    const gchar* body);
VALA_EXTERN Bubble* bubble_construct (GType object_type,
                          const gchar* summary,
                          const gchar* body);
VALA_EXTERN void bubble_show (Bubble* self);
VALA_EXTERN gboolean bubble_server_supports_actions (Bubble* self);
VALA_EXTERN void bubble_add_reconnect_action (Bubble* self);
VALA_EXTERN void bubble_add_approve_reject_actions (Bubble* self,
                                        const gchar* client_id,
                                        gchar** network_ids,
                                        gint network_ids_length1);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gchar* utils_remove_mnemonics (gchar* label);
static GVariant* _variant_new1 (gchar** value,
                         gint value_length1);
static GVariant* _variant_new2 (gchar** value,
                         gint value_length1);
static void bubble_finalize (GObject * obj);
static GType bubble_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
bubble_get_instance_private (Bubble* self)
{
	return G_STRUCT_MEMBER_P (self, Bubble_private_offset);
}

Bubble*
bubble_construct (GType object_type,
                  const gchar* summary,
                  const gchar* body)
{
	Bubble * self = NULL;
	GNotification* _tmp0_;
	GNotification* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (summary != NULL, NULL);
	g_return_val_if_fail (body != NULL, NULL);
	self = (Bubble*) g_object_new (object_type, NULL);
	_tmp0_ = g_notification_new (summary);
	_g_object_unref0 (self->priv->notification);
	self->priv->notification = _tmp0_;
	_tmp1_ = self->priv->notification;
	g_notification_set_body (_tmp1_, body);
	_tmp2_ = haguichi_current_desktop;
	if (g_strcmp0 (_tmp2_, "Pantheon") != 0) {
		GNotification* _tmp3_;
		GThemedIcon* _tmp4_;
		GThemedIcon* _tmp5_;
		_tmp3_ = self->priv->notification;
		_tmp4_ = (GThemedIcon*) g_themed_icon_new (CONFIG_ICON_NAME);
		_tmp5_ = _tmp4_;
		g_notification_set_icon (_tmp3_, (GIcon*) _tmp5_);
		_g_object_unref0 (_tmp5_);
	}
	return self;
}

Bubble*
bubble_new (const gchar* summary,
            const gchar* body)
{
	return bubble_construct (TYPE_BUBBLE, summary, body);
}

void
bubble_show (Bubble* self)
{
	GtkApplication* _tmp0_;
	GNotification* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = haguichi_app;
	_tmp1_ = self->priv->notification;
	g_application_send_notification ((GApplication*) _tmp0_, NULL, _tmp1_);
}

gboolean
bubble_server_supports_actions (Bubble* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = haguichi_current_desktop;
	if (g_str_has_prefix (_tmp1_, "Unity")) {
		_tmp0_ = FALSE;
	} else {
		_tmp0_ = TRUE;
	}
	result = _tmp0_;
	return result;
}

void
bubble_add_reconnect_action (Bubble* self)
{
	g_return_if_fail (self != NULL);
	if (bubble_server_supports_actions (self)) {
		GNotification* _tmp0_;
		const gchar* _tmp1_;
		_tmp0_ = self->priv->notification;
		_tmp1_ = text_reconnect_label;
		g_notification_add_button (_tmp0_, _tmp1_, "app.connect");
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static GVariant*
_variant_new1 (gchar** value,
               gint value_length1)
{
	gchar** _tmp17_;
	GVariantBuilder _tmp18_;
	gint _tmp19_;
	_tmp17_ = value;
	g_variant_builder_init (&_tmp18_, G_VARIANT_TYPE ("as"));
	for (_tmp19_ = 0; _tmp19_ < value_length1; _tmp19_++) {
		g_variant_builder_add_value (&_tmp18_, g_variant_new_string (*_tmp17_));
		_tmp17_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp18_));
}

static GVariant*
_variant_new2 (gchar** value,
               gint value_length1)
{
	gchar** _tmp27_;
	GVariantBuilder _tmp28_;
	gint _tmp29_;
	_tmp27_ = value;
	g_variant_builder_init (&_tmp28_, G_VARIANT_TYPE ("as"));
	for (_tmp29_ = 0; _tmp29_ < value_length1; _tmp29_++) {
		g_variant_builder_add_value (&_tmp28_, g_variant_new_string (*_tmp27_));
		_tmp27_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp28_));
}

void
bubble_add_approve_reject_actions (Bubble* self,
                                   const gchar* client_id,
                                   gchar** network_ids,
                                   gint network_ids_length1)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (client_id != NULL);
	if (bubble_server_supports_actions (self)) {
		gchar** approve_args = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar** _tmp2_;
		gint approve_args_length1;
		gint _approve_args_size_;
		gchar** reject_args = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar** _tmp5_;
		gint reject_args_length1;
		gint _reject_args_size_;
		GNotification* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar** _tmp16_;
		gint _tmp16__length1;
		GVariant* _tmp20_;
		GNotification* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar** _tmp26_;
		gint _tmp26__length1;
		GVariant* _tmp30_;
		_tmp0_ = g_strdup ("approve");
		_tmp1_ = g_strdup (client_id);
		_tmp2_ = g_new0 (gchar*, 2 + 1);
		_tmp2_[0] = _tmp0_;
		_tmp2_[1] = _tmp1_;
		approve_args = _tmp2_;
		approve_args_length1 = 2;
		_approve_args_size_ = approve_args_length1;
		_tmp3_ = g_strdup ("reject");
		_tmp4_ = g_strdup (client_id);
		_tmp5_ = g_new0 (gchar*, 2 + 1);
		_tmp5_[0] = _tmp3_;
		_tmp5_[1] = _tmp4_;
		reject_args = _tmp5_;
		reject_args_length1 = 2;
		_reject_args_size_ = reject_args_length1;
		{
			gchar** network_id_collection = NULL;
			gint network_id_collection_length1 = 0;
			gint _network_id_collection_size_ = 0;
			gint network_id_it = 0;
			network_id_collection = network_ids;
			network_id_collection_length1 = network_ids_length1;
			for (network_id_it = 0; network_id_it < network_id_collection_length1; network_id_it = network_id_it + 1) {
				gchar* _tmp6_;
				gchar* network_id = NULL;
				_tmp6_ = g_strdup (network_id_collection[network_id_it]);
				network_id = _tmp6_;
				{
					const gchar* _tmp7_;
					gchar* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					_tmp7_ = network_id;
					_tmp8_ = g_strdup (_tmp7_);
					_vala_array_add1 (&approve_args, &approve_args_length1, &_approve_args_size_, _tmp8_);
					_tmp9_ = network_id;
					_tmp10_ = g_strdup (_tmp9_);
					_vala_array_add2 (&reject_args, &reject_args_length1, &_reject_args_size_, _tmp10_);
					_g_free0 (network_id);
				}
			}
		}
		_tmp11_ = self->priv->notification;
		_tmp12_ = text_approve_label;
		_tmp13_ = g_strdup (_tmp12_);
		_tmp14_ = utils_remove_mnemonics (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = approve_args;
		_tmp16__length1 = approve_args_length1;
		_tmp20_ = _variant_new1 (_tmp16_, _tmp16__length1);
		g_notification_add_button_with_target_value (_tmp11_, _tmp15_, "app.approve-reject", _tmp20_);
		_g_variant_unref0 (_tmp20_);
		_g_free0 (_tmp15_);
		_tmp21_ = self->priv->notification;
		_tmp22_ = text_reject_label;
		_tmp23_ = g_strdup (_tmp22_);
		_tmp24_ = utils_remove_mnemonics (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = reject_args;
		_tmp26__length1 = reject_args_length1;
		_tmp30_ = _variant_new2 (_tmp26_, _tmp26__length1);
		g_notification_add_button_with_target_value (_tmp21_, _tmp25_, "app.approve-reject", _tmp30_);
		_g_variant_unref0 (_tmp30_);
		_g_free0 (_tmp25_);
		reject_args = (_vala_array_free (reject_args, reject_args_length1, (GDestroyNotify) g_free), NULL);
		approve_args = (_vala_array_free (approve_args, approve_args_length1, (GDestroyNotify) g_free), NULL);
	}
}

static void
bubble_class_init (BubbleClass * klass,
                   gpointer klass_data)
{
	bubble_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Bubble_private_offset);
	G_OBJECT_CLASS (klass)->finalize = bubble_finalize;
}

static void
bubble_instance_init (Bubble * self,
                      gpointer klass)
{
	self->priv = bubble_get_instance_private (self);
}

static void
bubble_finalize (GObject * obj)
{
	Bubble * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BUBBLE, Bubble);
	_g_object_unref0 (self->priv->notification);
	G_OBJECT_CLASS (bubble_parent_class)->finalize (obj);
}

static GType
bubble_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BubbleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bubble_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bubble), 0, (GInstanceInitFunc) bubble_instance_init, NULL };
	GType bubble_type_id;
	bubble_type_id = g_type_register_static (G_TYPE_OBJECT, "Bubble", &g_define_type_info, 0);
	Bubble_private_offset = g_type_add_instance_private (bubble_type_id, sizeof (BubblePrivate));
	return bubble_type_id;
}

GType
bubble_get_type (void)
{
	static volatile gsize bubble_type_id__volatile = 0;
	if (g_once_init_enter (&bubble_type_id__volatile)) {
		GType bubble_type_id;
		bubble_type_id = bubble_get_type_once ();
		g_once_init_leave (&bubble_type_id__volatile, bubble_type_id);
	}
	return bubble_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

