/* global-actions.c generated by valac 0.54.6, the Vala compiler
 * generated from global-actions.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2021 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#define SETTINGS_schema_base_id "com.github.ztefn.haguichi"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_GLOBAL_ACTIONS (global_actions_get_type ())
#define GLOBAL_ACTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GLOBAL_ACTIONS, GlobalActions))
#define GLOBAL_ACTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GLOBAL_ACTIONS, GlobalActionsClass))
#define IS_GLOBAL_ACTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GLOBAL_ACTIONS))
#define IS_GLOBAL_ACTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GLOBAL_ACTIONS))
#define GLOBAL_ACTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GLOBAL_ACTIONS, GlobalActionsClass))

typedef struct _GlobalActions GlobalActions;
typedef struct _GlobalActionsClass GlobalActionsClass;
typedef struct _GlobalActionsPrivate GlobalActionsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	DEBUG_DOMAIN_ERROR,
	DEBUG_DOMAIN_INFO,
	DEBUG_DOMAIN_HAMACHI,
	DEBUG_DOMAIN_ENVIRONMENT,
	DEBUG_DOMAIN_GUI
} Debugdomain;

#define DEBUG_TYPE_DOMAIN (debug_domain_get_type ())

#define TYPE_KEY (key_get_type ())
#define KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY, Key))
#define KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY, KeyClass))
#define IS_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY))
#define IS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY))
#define KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY, KeyClass))

typedef struct _Key Key;
typedef struct _KeyClass KeyClass;
typedef struct _KeyPrivate KeyPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecGlobalActions ParamSpecGlobalActions;

struct _GlobalActions {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GlobalActionsPrivate * priv;
};

struct _GlobalActionsClass {
	GTypeClass parent_class;
	void (*finalize) (GlobalActions *self);
};

struct _Key {
	GObject parent_instance;
	KeyPrivate * priv;
	gchar* parent;
	gchar* key_name;
};

struct _KeyClass {
	GObjectClass parent_class;
};

struct _ParamSpecGlobalActions {
	GParamSpec parent_instance;
};

static gpointer global_actions_parent_class = NULL;
VALA_EXTERN GSimpleAction* global_actions_connect;
GSimpleAction* global_actions_connect = NULL;
VALA_EXTERN GSimpleAction* global_actions_disconnect;
GSimpleAction* global_actions_disconnect = NULL;
VALA_EXTERN GSimpleAction* global_actions_approve_reject;
GSimpleAction* global_actions_approve_reject = NULL;
VALA_EXTERN GSimpleAction* global_actions_join_network;
GSimpleAction* global_actions_join_network = NULL;
VALA_EXTERN GSimpleAction* global_actions_create_network;
GSimpleAction* global_actions_create_network = NULL;
VALA_EXTERN GSimpleAction* global_actions_refresh;
GSimpleAction* global_actions_refresh = NULL;
VALA_EXTERN GSimpleAction* global_actions_start_search;
GSimpleAction* global_actions_start_search = NULL;
VALA_EXTERN GSimpleAction* global_actions_stop_search;
GSimpleAction* global_actions_stop_search = NULL;
VALA_EXTERN GSimpleAction* global_actions_copy_ipv4;
GSimpleAction* global_actions_copy_ipv4 = NULL;
VALA_EXTERN GSimpleAction* global_actions_copy_ipv6;
GSimpleAction* global_actions_copy_ipv6 = NULL;
VALA_EXTERN GSimpleAction* global_actions_copy_id;
GSimpleAction* global_actions_copy_id = NULL;
VALA_EXTERN GSimpleAction* global_actions_change_nick;
GSimpleAction* global_actions_change_nick = NULL;
VALA_EXTERN GSimpleAction* global_actions_open_config;
GSimpleAction* global_actions_open_config = NULL;
VALA_EXTERN GSimpleAction* global_actions_save_config;
GSimpleAction* global_actions_save_config = NULL;
VALA_EXTERN GSimpleAction* global_actions_restore_config;
GSimpleAction* global_actions_restore_config = NULL;
VALA_EXTERN GAction* global_actions_sort_by;
GAction* global_actions_sort_by = NULL;
VALA_EXTERN GAction* global_actions_show_offline;
GAction* global_actions_show_offline = NULL;
VALA_EXTERN GSimpleAction* global_actions_preferences;
GSimpleAction* global_actions_preferences = NULL;
VALA_EXTERN GSimpleAction* global_actions_info;
GSimpleAction* global_actions_info = NULL;
VALA_EXTERN GSimpleAction* global_actions_shortcuts;
GSimpleAction* global_actions_shortcuts = NULL;
VALA_EXTERN GSimpleAction* global_actions_help;
GSimpleAction* global_actions_help = NULL;
VALA_EXTERN GSimpleAction* global_actions_about;
GSimpleAction* global_actions_about = NULL;
VALA_EXTERN GSimpleAction* global_actions_quit;
GSimpleAction* global_actions_quit = NULL;
VALA_EXTERN gint controller_last_status;
VALA_EXTERN Key* settings_sort_network_list_by;
VALA_EXTERN Key* settings_show_offline_members;

VALA_EXTERN gpointer global_actions_ref (gpointer instance);
VALA_EXTERN void global_actions_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_global_actions (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_global_actions (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_global_actions (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_global_actions (const GValue* value);
VALA_EXTERN GType global_actions_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GlobalActions, global_actions_unref)
VALA_EXTERN void global_actions_init (GtkApplication* app);
VALA_EXTERN void global_events_start_hamachi (void);
static void _global_events_start_hamachi_g_simple_action_activate (GSimpleAction* _sender,
                                                            GVariant* parameter,
                                                            gpointer self);
VALA_EXTERN void global_events_stop_hamachi (void);
static void _global_events_stop_hamachi_g_simple_action_activate (GSimpleAction* _sender,
                                                           GVariant* parameter,
                                                           gpointer self);
static void __lambda84_ (GVariant* variant);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN void global_events_approve_or_reject (const gchar* action,
                                      const gchar* client_id,
                                      gchar** network_ids,
                                      gint network_ids_length1);
VALA_EXTERN GType debug_domain_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void debug_log (Debugdomain _domain,
                const gchar* reporter,
                const gchar* output);
static void ___lambda84__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
VALA_EXTERN void global_events_join_network (void);
static void _global_events_join_network_g_simple_action_activate (GSimpleAction* _sender,
                                                           GVariant* parameter,
                                                           gpointer self);
VALA_EXTERN void global_events_create_network (void);
static void _global_events_create_network_g_simple_action_activate (GSimpleAction* _sender,
                                                             GVariant* parameter,
                                                             gpointer self);
static void __lambda85_ (void);
VALA_EXTERN void controller_init (void);
VALA_EXTERN void controller_update_connection (void);
static void ___lambda85__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
VALA_EXTERN void global_events_start_search (void);
static void _global_events_start_search_g_simple_action_activate (GSimpleAction* _sender,
                                                           GVariant* parameter,
                                                           gpointer self);
VALA_EXTERN void global_events_stop_search (void);
static void _global_events_stop_search_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_copy_ipv4_to_clipboard (void);
static void _global_events_copy_ipv4_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                     GVariant* parameter,
                                                                     gpointer self);
VALA_EXTERN void global_events_copy_ipv6_to_clipboard (void);
static void _global_events_copy_ipv6_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                     GVariant* parameter,
                                                                     gpointer self);
VALA_EXTERN void global_events_copy_client_id_to_clipboard (void);
static void _global_events_copy_client_id_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                          GVariant* parameter,
                                                                          gpointer self);
VALA_EXTERN void global_events_change_nick (void);
static void _global_events_change_nick_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_open_config (void);
static void _global_events_open_config_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_save_config (void);
static void _global_events_save_config_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_restore_config (void);
static void _global_events_restore_config_g_simple_action_activate (GSimpleAction* _sender,
                                                             GVariant* parameter,
                                                             gpointer self);
VALA_EXTERN GType key_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Key, g_object_unref)
VALA_EXTERN void global_events_preferences (void);
static void _global_events_preferences_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_information (void);
static void _global_events_information_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self);
VALA_EXTERN void global_events_shortcuts (void);
static void _global_events_shortcuts_g_simple_action_activate (GSimpleAction* _sender,
                                                        GVariant* parameter,
                                                        gpointer self);
VALA_EXTERN void global_events_help (void);
static void _global_events_help_g_simple_action_activate (GSimpleAction* _sender,
                                                   GVariant* parameter,
                                                   gpointer self);
VALA_EXTERN void global_events_about (void);
static void _global_events_about_g_simple_action_activate (GSimpleAction* _sender,
                                                    GVariant* parameter,
                                                    gpointer self);
VALA_EXTERN void global_events_quit_app (void);
static void _global_events_quit_app_g_simple_action_activate (GSimpleAction* _sender,
                                                       GVariant* parameter,
                                                       gpointer self);
VALA_EXTERN GlobalActions* global_actions_new (void);
VALA_EXTERN GlobalActions* global_actions_construct (GType object_type);
static void global_actions_finalize (GlobalActions * obj);
static GType global_actions_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static void
_global_events_start_hamachi_g_simple_action_activate (GSimpleAction* _sender,
                                                       GVariant* parameter,
                                                       gpointer self)
{
	global_events_start_hamachi ();
}

static void
_global_events_stop_hamachi_g_simple_action_activate (GSimpleAction* _sender,
                                                      GVariant* parameter,
                                                      gpointer self)
{
	global_events_stop_hamachi ();
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
__lambda84_ (GVariant* variant)
{
	gchar** args = NULL;
	gsize _tmp0_ = 0;
	const gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint args_length1;
	gint _args_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	_tmp1_ = g_variant_get_strv (variant, &_tmp0_);
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup3 (_tmp1_, _tmp0_) : _tmp1_;
	_tmp2__length1 = _tmp0_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	args = _tmp2_;
	args_length1 = _tmp2__length1;
	_args_size_ = args_length1;
	_tmp3_ = args;
	_tmp3__length1 = args_length1;
	if (_tmp3__length1 > 2) {
		gchar** network_ids = NULL;
		gchar** _tmp4_;
		gint network_ids_length1;
		gint _network_ids_size_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		const gchar* _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		_tmp4_ = g_new0 (gchar*, 0 + 1);
		network_ids = _tmp4_;
		network_ids_length1 = 0;
		_network_ids_size_ = network_ids_length1;
		{
			gint i = 0;
			i = 2;
			{
				gboolean _tmp5_ = FALSE;
				_tmp5_ = TRUE;
				while (TRUE) {
					gchar** _tmp7_;
					gint _tmp7__length1;
					gchar** _tmp8_;
					gint _tmp8__length1;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					if (!_tmp5_) {
						gint _tmp6_;
						_tmp6_ = i;
						i = _tmp6_ + 1;
					}
					_tmp5_ = FALSE;
					_tmp7_ = args;
					_tmp7__length1 = args_length1;
					if (!(i < _tmp7__length1)) {
						break;
					}
					_tmp8_ = args;
					_tmp8__length1 = args_length1;
					_tmp9_ = _tmp8_[i];
					_tmp10_ = g_strdup (_tmp9_);
					_vala_array_add4 (&network_ids, &network_ids_length1, &_network_ids_size_, _tmp10_);
				}
			}
		}
		_tmp11_ = args;
		_tmp11__length1 = args_length1;
		_tmp12_ = _tmp11_[0];
		_tmp13_ = args;
		_tmp13__length1 = args_length1;
		_tmp14_ = _tmp13_[1];
		_tmp15_ = network_ids;
		_tmp15__length1 = network_ids_length1;
		global_events_approve_or_reject (_tmp12_, _tmp14_, _tmp15_, (gint) _tmp15__length1);
		network_ids = (_vala_array_free (network_ids, network_ids_length1, (GDestroyNotify) g_free), NULL);
	} else {
		debug_log (DEBUG_DOMAIN_ERROR, "GlobalActions.approve_reject", "Too few arguments, expected \"action, client_id, network_id1, network_" \
"id2, ...\"");
	}
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
}

static void
___lambda84__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
	__lambda84_ (parameter);
}

static void
_global_events_join_network_g_simple_action_activate (GSimpleAction* _sender,
                                                      GVariant* parameter,
                                                      gpointer self)
{
	global_events_join_network ();
}

static void
_global_events_create_network_g_simple_action_activate (GSimpleAction* _sender,
                                                        GVariant* parameter,
                                                        gpointer self)
{
	global_events_create_network ();
}

static void
__lambda85_ (void)
{
	if (controller_last_status <= 1) {
		controller_init ();
	}
	if (controller_last_status >= 6) {
		controller_update_connection ();
	}
}

static void
___lambda85__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
	__lambda85_ ();
}

static void
_global_events_start_search_g_simple_action_activate (GSimpleAction* _sender,
                                                      GVariant* parameter,
                                                      gpointer self)
{
	global_events_start_search ();
}

static void
_global_events_stop_search_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
	global_events_stop_search ();
}

static void
_global_events_copy_ipv4_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self)
{
	global_events_copy_ipv4_to_clipboard ();
}

static void
_global_events_copy_ipv6_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                GVariant* parameter,
                                                                gpointer self)
{
	global_events_copy_ipv6_to_clipboard ();
}

static void
_global_events_copy_client_id_to_clipboard_g_simple_action_activate (GSimpleAction* _sender,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
	global_events_copy_client_id_to_clipboard ();
}

static void
_global_events_change_nick_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
	global_events_change_nick ();
}

static void
_global_events_open_config_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
	global_events_open_config ();
}

static void
_global_events_save_config_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
	global_events_save_config ();
}

static void
_global_events_restore_config_g_simple_action_activate (GSimpleAction* _sender,
                                                        GVariant* parameter,
                                                        gpointer self)
{
	global_events_restore_config ();
}

static void
_global_events_preferences_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
	global_events_preferences ();
}

static void
_global_events_information_g_simple_action_activate (GSimpleAction* _sender,
                                                     GVariant* parameter,
                                                     gpointer self)
{
	global_events_information ();
}

static void
_global_events_shortcuts_g_simple_action_activate (GSimpleAction* _sender,
                                                   GVariant* parameter,
                                                   gpointer self)
{
	global_events_shortcuts ();
}

static void
_global_events_help_g_simple_action_activate (GSimpleAction* _sender,
                                              GVariant* parameter,
                                              gpointer self)
{
	global_events_help ();
}

static void
_global_events_about_g_simple_action_activate (GSimpleAction* _sender,
                                               GVariant* parameter,
                                               gpointer self)
{
	global_events_about ();
}

static void
_global_events_quit_app_g_simple_action_activate (GSimpleAction* _sender,
                                                  GVariant* parameter,
                                                  gpointer self)
{
	global_events_quit_app ();
}

void
global_actions_init (GtkApplication* app)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	const GVariantType* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GSimpleAction* _tmp8_;
	GSimpleAction* _tmp9_;
	GSimpleAction* _tmp10_;
	GSimpleAction* _tmp11_;
	GSimpleAction* _tmp12_;
	GSimpleAction* _tmp13_;
	GSimpleAction* _tmp14_;
	GSimpleAction* _tmp15_;
	GSimpleAction* _tmp16_;
	GSimpleAction* _tmp17_;
	GSimpleAction* _tmp18_;
	GSimpleAction* _tmp19_;
	GSimpleAction* _tmp20_;
	GSimpleAction* _tmp21_;
	GSimpleAction* _tmp22_;
	GSimpleAction* _tmp23_;
	GSimpleAction* _tmp24_;
	GSimpleAction* _tmp25_;
	GSimpleAction* _tmp26_;
	GSimpleAction* _tmp27_;
	GSimpleAction* _tmp28_;
	GSimpleAction* _tmp29_;
	GSimpleAction* _tmp30_;
	Key* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	GSettings* _tmp35_;
	GSettings* _tmp36_;
	Key* _tmp37_;
	const gchar* _tmp38_;
	GAction* _tmp39_;
	Key* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GSettings* _tmp44_;
	GSettings* _tmp45_;
	Key* _tmp46_;
	const gchar* _tmp47_;
	GAction* _tmp48_;
	GSimpleAction* _tmp49_;
	GSimpleAction* _tmp50_;
	GSimpleAction* _tmp51_;
	GSimpleAction* _tmp52_;
	GSimpleAction* _tmp53_;
	GSimpleAction* _tmp54_;
	GSimpleAction* _tmp55_;
	GSimpleAction* _tmp56_;
	GSimpleAction* _tmp57_;
	GSimpleAction* _tmp58_;
	GSimpleAction* _tmp59_;
	GSimpleAction* _tmp60_;
	GSimpleAction* _tmp61_;
	GSimpleAction* _tmp62_;
	GSimpleAction* _tmp63_;
	GSimpleAction* _tmp64_;
	GSimpleAction* _tmp65_;
	GSimpleAction* _tmp66_;
	GSimpleAction* _tmp67_;
	GSimpleAction* _tmp68_;
	GSimpleAction* _tmp69_;
	GSimpleAction* _tmp70_;
	GSimpleAction* _tmp71_;
	GSimpleAction* _tmp72_;
	GSimpleAction* _tmp73_;
	GSimpleAction* _tmp74_;
	GSimpleAction* _tmp75_;
	GAction* _tmp76_;
	GAction* _tmp77_;
	GSimpleAction* _tmp78_;
	GSimpleAction* _tmp79_;
	GSimpleAction* _tmp80_;
	GSimpleAction* _tmp81_;
	GSimpleAction* _tmp82_;
	GSimpleAction* _tmp83_;
	gchar* _tmp84_;
	gchar** _tmp85_;
	gchar** _tmp86_;
	gint _tmp86__length1;
	gchar* _tmp87_;
	gchar** _tmp88_;
	gchar** _tmp89_;
	gint _tmp89__length1;
	gchar* _tmp90_;
	gchar** _tmp91_;
	gchar** _tmp92_;
	gint _tmp92__length1;
	gchar* _tmp93_;
	gchar** _tmp94_;
	gchar** _tmp95_;
	gint _tmp95__length1;
	gchar* _tmp96_;
	gchar* _tmp97_;
	gchar** _tmp98_;
	gchar** _tmp99_;
	gint _tmp99__length1;
	gchar* _tmp100_;
	gchar** _tmp101_;
	gchar** _tmp102_;
	gint _tmp102__length1;
	Key* _tmp103_;
	const gchar* _tmp104_;
	gchar* _tmp105_;
	gchar* _tmp106_;
	gchar* _tmp107_;
	gchar** _tmp108_;
	gchar** _tmp109_;
	gint _tmp109__length1;
	gchar* _tmp110_;
	gchar** _tmp111_;
	gchar** _tmp112_;
	gint _tmp112__length1;
	gchar* _tmp113_;
	gchar* _tmp114_;
	gchar** _tmp115_;
	gchar** _tmp116_;
	gint _tmp116__length1;
	gchar* _tmp117_;
	gchar** _tmp118_;
	gchar** _tmp119_;
	gint _tmp119__length1;
	gchar* _tmp120_;
	gchar** _tmp121_;
	gchar** _tmp122_;
	gint _tmp122__length1;
	gchar* _tmp123_;
	gchar** _tmp124_;
	gchar** _tmp125_;
	gint _tmp125__length1;
	g_return_if_fail (app != NULL);
	_tmp0_ = g_simple_action_new ("connect", NULL);
	_g_object_unref0 (global_actions_connect);
	global_actions_connect = _tmp0_;
	_tmp1_ = global_actions_connect;
	g_signal_connect (_tmp1_, "activate", (GCallback) _global_events_start_hamachi_g_simple_action_activate, NULL);
	_tmp2_ = g_simple_action_new ("disconnect", NULL);
	_g_object_unref0 (global_actions_disconnect);
	global_actions_disconnect = _tmp2_;
	_tmp3_ = global_actions_disconnect;
	g_signal_connect (_tmp3_, "activate", (GCallback) _global_events_stop_hamachi_g_simple_action_activate, NULL);
	_tmp4_ = G_VARIANT_TYPE_STRING_ARRAY;
	_tmp5_ = g_simple_action_new ("approve-reject", _tmp4_);
	_g_object_unref0 (global_actions_approve_reject);
	global_actions_approve_reject = _tmp5_;
	_tmp6_ = global_actions_approve_reject;
	g_signal_connect (_tmp6_, "activate", (GCallback) ___lambda84__g_simple_action_activate, NULL);
	_tmp7_ = g_simple_action_new ("join-network", NULL);
	_g_object_unref0 (global_actions_join_network);
	global_actions_join_network = _tmp7_;
	_tmp8_ = global_actions_join_network;
	g_signal_connect (_tmp8_, "activate", (GCallback) _global_events_join_network_g_simple_action_activate, NULL);
	_tmp9_ = g_simple_action_new ("create-network", NULL);
	_g_object_unref0 (global_actions_create_network);
	global_actions_create_network = _tmp9_;
	_tmp10_ = global_actions_create_network;
	g_signal_connect (_tmp10_, "activate", (GCallback) _global_events_create_network_g_simple_action_activate, NULL);
	_tmp11_ = g_simple_action_new ("refresh", NULL);
	_g_object_unref0 (global_actions_refresh);
	global_actions_refresh = _tmp11_;
	_tmp12_ = global_actions_refresh;
	g_signal_connect (_tmp12_, "activate", (GCallback) ___lambda85__g_simple_action_activate, NULL);
	_tmp13_ = g_simple_action_new ("start-search", NULL);
	_g_object_unref0 (global_actions_start_search);
	global_actions_start_search = _tmp13_;
	_tmp14_ = global_actions_start_search;
	g_signal_connect (_tmp14_, "activate", (GCallback) _global_events_start_search_g_simple_action_activate, NULL);
	_tmp15_ = g_simple_action_new ("stop-search", NULL);
	_g_object_unref0 (global_actions_stop_search);
	global_actions_stop_search = _tmp15_;
	_tmp16_ = global_actions_stop_search;
	g_signal_connect (_tmp16_, "activate", (GCallback) _global_events_stop_search_g_simple_action_activate, NULL);
	_tmp17_ = g_simple_action_new ("copy-ipv4", NULL);
	_g_object_unref0 (global_actions_copy_ipv4);
	global_actions_copy_ipv4 = _tmp17_;
	_tmp18_ = global_actions_copy_ipv4;
	g_signal_connect (_tmp18_, "activate", (GCallback) _global_events_copy_ipv4_to_clipboard_g_simple_action_activate, NULL);
	_tmp19_ = g_simple_action_new ("copy-ipv6", NULL);
	_g_object_unref0 (global_actions_copy_ipv6);
	global_actions_copy_ipv6 = _tmp19_;
	_tmp20_ = global_actions_copy_ipv6;
	g_signal_connect (_tmp20_, "activate", (GCallback) _global_events_copy_ipv6_to_clipboard_g_simple_action_activate, NULL);
	_tmp21_ = g_simple_action_new ("copy-id", NULL);
	_g_object_unref0 (global_actions_copy_id);
	global_actions_copy_id = _tmp21_;
	_tmp22_ = global_actions_copy_id;
	g_signal_connect (_tmp22_, "activate", (GCallback) _global_events_copy_client_id_to_clipboard_g_simple_action_activate, NULL);
	_tmp23_ = g_simple_action_new ("change-nick", NULL);
	_g_object_unref0 (global_actions_change_nick);
	global_actions_change_nick = _tmp23_;
	_tmp24_ = global_actions_change_nick;
	g_signal_connect (_tmp24_, "activate", (GCallback) _global_events_change_nick_g_simple_action_activate, NULL);
	_tmp25_ = g_simple_action_new ("open-config", NULL);
	_g_object_unref0 (global_actions_open_config);
	global_actions_open_config = _tmp25_;
	_tmp26_ = global_actions_open_config;
	g_signal_connect (_tmp26_, "activate", (GCallback) _global_events_open_config_g_simple_action_activate, NULL);
	_tmp27_ = g_simple_action_new ("save-config", NULL);
	_g_object_unref0 (global_actions_save_config);
	global_actions_save_config = _tmp27_;
	_tmp28_ = global_actions_save_config;
	g_signal_connect (_tmp28_, "activate", (GCallback) _global_events_save_config_g_simple_action_activate, NULL);
	_tmp29_ = g_simple_action_new ("restore-config", NULL);
	_g_object_unref0 (global_actions_restore_config);
	global_actions_restore_config = _tmp29_;
	_tmp30_ = global_actions_restore_config;
	g_signal_connect (_tmp30_, "activate", (GCallback) _global_events_restore_config_g_simple_action_activate, NULL);
	_tmp31_ = settings_sort_network_list_by;
	_tmp32_ = _tmp31_->parent;
	_tmp33_ = g_strconcat (SETTINGS_schema_base_id ".", _tmp32_, NULL);
	_tmp34_ = _tmp33_;
	_tmp35_ = g_settings_new (_tmp34_);
	_tmp36_ = _tmp35_;
	_tmp37_ = settings_sort_network_list_by;
	_tmp38_ = _tmp37_->key_name;
	_tmp39_ = g_settings_create_action (_tmp36_, _tmp38_);
	_g_object_unref0 (global_actions_sort_by);
	global_actions_sort_by = _tmp39_;
	_g_object_unref0 (_tmp36_);
	_g_free0 (_tmp34_);
	_tmp40_ = settings_show_offline_members;
	_tmp41_ = _tmp40_->parent;
	_tmp42_ = g_strconcat (SETTINGS_schema_base_id ".", _tmp41_, NULL);
	_tmp43_ = _tmp42_;
	_tmp44_ = g_settings_new (_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = settings_show_offline_members;
	_tmp47_ = _tmp46_->key_name;
	_tmp48_ = g_settings_create_action (_tmp45_, _tmp47_);
	_g_object_unref0 (global_actions_show_offline);
	global_actions_show_offline = _tmp48_;
	_g_object_unref0 (_tmp45_);
	_g_free0 (_tmp43_);
	_tmp49_ = g_simple_action_new ("preferences", NULL);
	_g_object_unref0 (global_actions_preferences);
	global_actions_preferences = _tmp49_;
	_tmp50_ = global_actions_preferences;
	g_signal_connect (_tmp50_, "activate", (GCallback) _global_events_preferences_g_simple_action_activate, NULL);
	_tmp51_ = g_simple_action_new ("info", NULL);
	_g_object_unref0 (global_actions_info);
	global_actions_info = _tmp51_;
	_tmp52_ = global_actions_info;
	g_signal_connect (_tmp52_, "activate", (GCallback) _global_events_information_g_simple_action_activate, NULL);
	_tmp53_ = g_simple_action_new ("shortcuts", NULL);
	_g_object_unref0 (global_actions_shortcuts);
	global_actions_shortcuts = _tmp53_;
	_tmp54_ = global_actions_shortcuts;
	g_signal_connect (_tmp54_, "activate", (GCallback) _global_events_shortcuts_g_simple_action_activate, NULL);
	_tmp55_ = g_simple_action_new ("help", NULL);
	_g_object_unref0 (global_actions_help);
	global_actions_help = _tmp55_;
	_tmp56_ = global_actions_help;
	g_signal_connect (_tmp56_, "activate", (GCallback) _global_events_help_g_simple_action_activate, NULL);
	_tmp57_ = g_simple_action_new ("about", NULL);
	_g_object_unref0 (global_actions_about);
	global_actions_about = _tmp57_;
	_tmp58_ = global_actions_about;
	g_signal_connect (_tmp58_, "activate", (GCallback) _global_events_about_g_simple_action_activate, NULL);
	_tmp59_ = g_simple_action_new ("quit", NULL);
	_g_object_unref0 (global_actions_quit);
	global_actions_quit = _tmp59_;
	_tmp60_ = global_actions_quit;
	g_signal_connect (_tmp60_, "activate", (GCallback) _global_events_quit_app_g_simple_action_activate, NULL);
	_tmp61_ = global_actions_connect;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp61_);
	_tmp62_ = global_actions_disconnect;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp62_);
	_tmp63_ = global_actions_approve_reject;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp63_);
	_tmp64_ = global_actions_join_network;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp64_);
	_tmp65_ = global_actions_create_network;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp65_);
	_tmp66_ = global_actions_refresh;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp66_);
	_tmp67_ = global_actions_start_search;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp67_);
	_tmp68_ = global_actions_stop_search;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp68_);
	_tmp69_ = global_actions_copy_ipv4;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp69_);
	_tmp70_ = global_actions_copy_ipv6;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp70_);
	_tmp71_ = global_actions_copy_id;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp71_);
	_tmp72_ = global_actions_change_nick;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp72_);
	_tmp73_ = global_actions_open_config;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp73_);
	_tmp74_ = global_actions_save_config;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp74_);
	_tmp75_ = global_actions_restore_config;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp75_);
	_tmp76_ = global_actions_sort_by;
	g_action_map_add_action ((GActionMap*) app, _tmp76_);
	_tmp77_ = global_actions_show_offline;
	g_action_map_add_action ((GActionMap*) app, _tmp77_);
	_tmp78_ = global_actions_preferences;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp78_);
	_tmp79_ = global_actions_shortcuts;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp79_);
	_tmp80_ = global_actions_info;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp80_);
	_tmp81_ = global_actions_help;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp81_);
	_tmp82_ = global_actions_about;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp82_);
	_tmp83_ = global_actions_quit;
	g_action_map_add_action ((GActionMap*) app, (GAction*) _tmp83_);
	_tmp84_ = g_strdup ("<Control>O");
	_tmp85_ = g_new0 (gchar*, 1 + 1);
	_tmp85_[0] = _tmp84_;
	_tmp86_ = _tmp85_;
	_tmp86__length1 = 1;
	gtk_application_set_accels_for_action (app, "app.connect", _tmp86_);
	_tmp86_ = (_vala_array_free (_tmp86_, _tmp86__length1, (GDestroyNotify) g_free), NULL);
	_tmp87_ = g_strdup ("<Control>D");
	_tmp88_ = g_new0 (gchar*, 1 + 1);
	_tmp88_[0] = _tmp87_;
	_tmp89_ = _tmp88_;
	_tmp89__length1 = 1;
	gtk_application_set_accels_for_action (app, "app.disconnect", _tmp89_);
	_tmp89_ = (_vala_array_free (_tmp89_, _tmp89__length1, (GDestroyNotify) g_free), NULL);
	_tmp90_ = g_strdup ("<Control>J");
	_tmp91_ = g_new0 (gchar*, 1 + 1);
	_tmp91_[0] = _tmp90_;
	_tmp92_ = _tmp91_;
	_tmp92__length1 = 1;
	gtk_application_set_accels_for_action (app, "app.join-network", _tmp92_);
	_tmp92_ = (_vala_array_free (_tmp92_, _tmp92__length1, (GDestroyNotify) g_free), NULL);
	_tmp93_ = g_strdup ("<Control>N");
	_tmp94_ = g_new0 (gchar*, 1 + 1);
	_tmp94_[0] = _tmp93_;
	_tmp95_ = _tmp94_;
	_tmp95__length1 = 1;
	gtk_application_set_accels_for_action (app, "app.create-network", _tmp95_);
	_tmp95_ = (_vala_array_free (_tmp95_, _tmp95__length1, (GDestroyNotify) g_free), NULL);
	_tmp96_ = g_strdup ("F5");
	_tmp97_ = g_strdup ("<Control>R");
	_tmp98_ = g_new0 (gchar*, 2 + 1);
	_tmp98_[0] = _tmp96_;
	_tmp98_[1] = _tmp97_;
	_tmp99_ = _tmp98_;
	_tmp99__length1 = 2;
	gtk_application_set_accels_for_action (app, "app.refresh", _tmp99_);
	_tmp99_ = (_vala_array_free (_tmp99_, _tmp99__length1, (GDestroyNotify) g_free), NULL);
	_tmp100_ = g_strdup ("<Control>F");
	_tmp101_ = g_new0 (gchar*, 1 + 1);
	_tmp101_[0] = _tmp100_;
	_tmp102_ = _tmp101_;
	_tmp102__length1 = 1;
	gtk_application_set_accels_for_action (app, "app.start-search", _tmp102_);
	_tmp102_ = (_vala_array_free (_tmp102_, _tmp102__length1, (GDestroyNotify) g_free), NULL);
	_tmp103_ = settings_show_offline_members;
	_tmp104_ = _tmp103_->key_name;
	_tmp105_ = g_strconcat ("app.", _tmp104_, NULL);
	_tmp106_ = _tmp105_;
	_tmp107_ = g_strdup ("<Control>M");
	_tmp108_ = g_new0 (gchar*, 1 + 1);
	_tmp108_[0] = _tmp107_;
	_tmp109_ = _tmp108_;
	_tmp109__length1 = 1;
	gtk_application_set_accels_for_action (app, _tmp106_, _tmp109_);
	_tmp109_ = (_vala_array_free (_tmp109_, _tmp109__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp106_);
	_tmp110_ = g_strdup ("<Control>P");
	_tmp111_ = g_new0 (gchar*, 1 + 1);
	_tmp111_[0] = _tmp110_;
	_tmp112_ = _tmp111_;
	_tmp112__length1 = 1;
	gtk_application_set_accels_for_action (app, "app.preferences", _tmp112_);
	_tmp112_ = (_vala_array_free (_tmp112_, _tmp112__length1, (GDestroyNotify) g_free), NULL);
	_tmp113_ = g_strdup ("<Control>F1");
	_tmp114_ = g_strdup ("<Control>question");
	_tmp115_ = g_new0 (gchar*, 2 + 1);
	_tmp115_[0] = _tmp113_;
	_tmp115_[1] = _tmp114_;
	_tmp116_ = _tmp115_;
	_tmp116__length1 = 2;
	gtk_application_set_accels_for_action (app, "app.shortcuts", _tmp116_);
	_tmp116_ = (_vala_array_free (_tmp116_, _tmp116__length1, (GDestroyNotify) g_free), NULL);
	_tmp117_ = g_strdup ("F2");
	_tmp118_ = g_new0 (gchar*, 1 + 1);
	_tmp118_[0] = _tmp117_;
	_tmp119_ = _tmp118_;
	_tmp119__length1 = 1;
	gtk_application_set_accels_for_action (app, "app.info", _tmp119_);
	_tmp119_ = (_vala_array_free (_tmp119_, _tmp119__length1, (GDestroyNotify) g_free), NULL);
	_tmp120_ = g_strdup ("F1");
	_tmp121_ = g_new0 (gchar*, 1 + 1);
	_tmp121_[0] = _tmp120_;
	_tmp122_ = _tmp121_;
	_tmp122__length1 = 1;
	gtk_application_set_accels_for_action (app, "app.help", _tmp122_);
	_tmp122_ = (_vala_array_free (_tmp122_, _tmp122__length1, (GDestroyNotify) g_free), NULL);
	_tmp123_ = g_strdup ("<Control>Q");
	_tmp124_ = g_new0 (gchar*, 1 + 1);
	_tmp124_[0] = _tmp123_;
	_tmp125_ = _tmp124_;
	_tmp125__length1 = 1;
	gtk_application_set_accels_for_action (app, "app.quit", _tmp125_);
	_tmp125_ = (_vala_array_free (_tmp125_, _tmp125__length1, (GDestroyNotify) g_free), NULL);
}

GlobalActions*
global_actions_construct (GType object_type)
{
	GlobalActions* self = NULL;
	self = (GlobalActions*) g_type_create_instance (object_type);
	return self;
}

GlobalActions*
global_actions_new (void)
{
	return global_actions_construct (TYPE_GLOBAL_ACTIONS);
}

static void
value_global_actions_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_global_actions_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		global_actions_unref (value->data[0].v_pointer);
	}
}

static void
value_global_actions_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = global_actions_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_global_actions_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_global_actions_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GlobalActions * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = global_actions_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_global_actions_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	GlobalActions ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = global_actions_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_global_actions (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecGlobalActions* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_GLOBAL_ACTIONS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_global_actions (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GLOBAL_ACTIONS), NULL);
	return value->data[0].v_pointer;
}

void
value_set_global_actions (GValue* value,
                          gpointer v_object)
{
	GlobalActions * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GLOBAL_ACTIONS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GLOBAL_ACTIONS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		global_actions_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		global_actions_unref (old);
	}
}

void
value_take_global_actions (GValue* value,
                           gpointer v_object)
{
	GlobalActions * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_GLOBAL_ACTIONS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_GLOBAL_ACTIONS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		global_actions_unref (old);
	}
}

static void
global_actions_class_init (GlobalActionsClass * klass,
                           gpointer klass_data)
{
	global_actions_parent_class = g_type_class_peek_parent (klass);
	((GlobalActionsClass *) klass)->finalize = global_actions_finalize;
}

static void
global_actions_instance_init (GlobalActions * self,
                              gpointer klass)
{
	self->ref_count = 1;
}

static void
global_actions_finalize (GlobalActions * obj)
{
	GlobalActions * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GLOBAL_ACTIONS, GlobalActions);
	g_signal_handlers_destroy (self);
}

static GType
global_actions_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_global_actions_init, value_global_actions_free_value, value_global_actions_copy_value, value_global_actions_peek_pointer, "p", value_global_actions_collect_value, "p", value_global_actions_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GlobalActionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) global_actions_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GlobalActions), 0, (GInstanceInitFunc) global_actions_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType global_actions_type_id;
	global_actions_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GlobalActions", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return global_actions_type_id;
}

GType
global_actions_get_type (void)
{
	static volatile gsize global_actions_type_id__volatile = 0;
	if (g_once_init_enter (&global_actions_type_id__volatile)) {
		GType global_actions_type_id;
		global_actions_type_id = global_actions_get_type_once ();
		g_once_init_leave (&global_actions_type_id__volatile, global_actions_type_id);
	}
	return global_actions_type_id__volatile;
}

gpointer
global_actions_ref (gpointer instance)
{
	GlobalActions * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
global_actions_unref (gpointer instance)
{
	GlobalActions * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GLOBAL_ACTIONS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

