/* headerbar.c generated by valac 0.54.6, the Vala compiler
 * generated from headerbar.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2021 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_HEADERBAR (headerbar_get_type ())
#define HEADERBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HEADERBAR, Headerbar))
#define HEADERBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HEADERBAR, HeaderbarClass))
#define IS_HEADERBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HEADERBAR))
#define IS_HEADERBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HEADERBAR))
#define HEADERBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HEADERBAR, HeaderbarClass))

typedef struct _Headerbar Headerbar;
typedef struct _HeaderbarClass HeaderbarClass;
typedef struct _HeaderbarPrivate HeaderbarPrivate;
enum  {
	HEADERBAR_0_PROPERTY,
	HEADERBAR_NUM_PROPERTIES
};
static GParamSpec* headerbar_properties[HEADERBAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block20Data Block20Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _Headerbar {
	GtkHeaderBar parent_instance;
	HeaderbarPrivate * priv;
	GtkToggleButton* connect_but;
	GtkToggleButton* search_but;
};

struct _HeaderbarClass {
	GtkHeaderBarClass parent_class;
};

struct _HeaderbarPrivate {
	gchar* mode;
	GtkMenuButton* network_but;
	GtkMenuButton* client_but;
	GtkButton* refresh_but;
	GtkMenuButton* gear_but;
	GtkBox* box;
	gint minimum_width;
	gint last_allocated;
	gint connect_but_width;
	gint client_but_width;
	gint box_width;
	gint gear_but_width;
	gint search_but_width;
};

struct _Block20Data {
	int _ref_count_;
	Headerbar* self;
	GMenuItem* copy_ipv4;
	GMenuItem* copy_ipv6;
	GMenuItem* copy_id;
	GMenu* copy_section;
};

static gint Headerbar_private_offset;
static gpointer headerbar_parent_class = NULL;
VALA_EXTERN gboolean haguichi_window_use_header_bar;
VALA_EXTERN gchar* text_join_network_label;
VALA_EXTERN gchar* text_create_network_label;
VALA_EXTERN gchar* text_copy_address_ipv4_label;
VALA_EXTERN gchar* text_copy_address_ipv6_label;
VALA_EXTERN gchar* text_copy_client_id_label;
VALA_EXTERN gchar* text_change_nick_label;
VALA_EXTERN gchar* text_information_label;
VALA_EXTERN gchar* text_search_tip;
VALA_EXTERN gchar* text_refresh_tip;
VALA_EXTERN gchar* text_config_folder_label;
VALA_EXTERN gchar* text_config_save_label;
VALA_EXTERN gchar* text_config_restore_label;
VALA_EXTERN gchar* text_sort_by_name;
VALA_EXTERN gchar* text_sort_by_status;
VALA_EXTERN gchar* text_show_offline_members;
VALA_EXTERN gchar* text_preferences_label;
VALA_EXTERN gchar* text_shortcuts_label;
VALA_EXTERN gchar* text_help_label;
VALA_EXTERN gchar* text_about_label;
VALA_EXTERN gchar* text_quit_label;
VALA_EXTERN gchar* text_config_label;
VALA_EXTERN GtkAccelGroup* haguichi_window_accel_group;
VALA_EXTERN gint haguichi_window_minimum_width;
VALA_EXTERN GSimpleAction* global_actions_connect;
VALA_EXTERN GSimpleAction* global_actions_disconnect;
VALA_EXTERN GSimpleAction* global_actions_info;
VALA_EXTERN GSimpleAction* global_actions_join_network;
VALA_EXTERN GSimpleAction* global_actions_create_network;
VALA_EXTERN GSimpleAction* global_actions_refresh;
VALA_EXTERN GSimpleAction* global_actions_start_search;
VALA_EXTERN gchar* text_initializing;
VALA_EXTERN gint controller_restore_countdown;
VALA_EXTERN gchar* text_connecting;
VALA_EXTERN gchar* text_disconnect_tip;
VALA_EXTERN gchar* text_connected;
VALA_EXTERN gchar* text_connect_tip;
VALA_EXTERN gchar* text_disconnected;

VALA_EXTERN GType headerbar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Headerbar, g_object_unref)
VALA_EXTERN Headerbar* headerbar_new (void);
VALA_EXTERN Headerbar* headerbar_construct (GType object_type);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static void __lambda92_ (Block20Data* _data20_);
VALA_EXTERN gchar** hamachi_get_address (gint* result_length1);
VALA_EXTERN gchar* hamachi_get_client_id (void);
static void ___lambda92__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static GVariant* _variant_new5 (const gchar* value);
static GVariant* _variant_new6 (const gchar* value);
VALA_EXTERN void headerbar_hide_all_buttons (Headerbar* self);
VALA_EXTERN void headerbar_show_all_buttons (Headerbar* self);
VALA_EXTERN void headerbar_show_hide_buttons (Headerbar* self,
                                  gint allocated,
                                  gint minimum);
static void headerbar_real_get_preferred_width (GtkWidget* base,
                                         gint* new_minimum_width,
                                         gint* new_natural_width);
VALA_EXTERN void headerbar_set_mode (Headerbar* self,
                         const gchar* _mode);
VALA_EXTERN gchar* utils_format (gchar* text,
                     const gchar* param1,
                     const gchar* param2,
                     const gchar* param3);
VALA_EXTERN gchar* text_reconnecting (gint count);
VALA_EXTERN void global_events_stop_search (void);
static void headerbar_finalize (GObject * obj);
static GType headerbar_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
headerbar_get_instance_private (Headerbar* self)
{
	return G_STRUCT_MEMBER_P (self, Headerbar_private_offset);
}

static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
	g_atomic_int_inc (&_data20_->_ref_count_);
	return _data20_;
}

static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
		Headerbar* self;
		self = _data20_->self;
		_g_object_unref0 (_data20_->copy_section);
		_g_object_unref0 (_data20_->copy_id);
		_g_object_unref0 (_data20_->copy_ipv6);
		_g_object_unref0 (_data20_->copy_ipv4);
		_g_object_unref0 (self);
		g_slice_free (Block20Data, _data20_);
	}
}

static void
__lambda92_ (Block20Data* _data20_)
{
	Headerbar* self;
	GtkMenuButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data20_->self;
	_tmp0_ = self->priv->client_but;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		gchar** address = NULL;
		gint _tmp3_ = 0;
		gchar** _tmp4_;
		gint address_length1;
		gint _address_size_;
		gchar* ipv4 = NULL;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* ipv6 = NULL;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean _tmp15_;
		_tmp4_ = hamachi_get_address (&_tmp3_);
		address = _tmp4_;
		address_length1 = _tmp3_;
		_address_size_ = address_length1;
		_tmp5_ = address;
		_tmp5__length1 = address_length1;
		_tmp6_ = _tmp5_[0];
		_tmp7_ = g_strdup (_tmp6_);
		ipv4 = _tmp7_;
		_tmp8_ = address;
		_tmp8__length1 = address_length1;
		_tmp9_ = _tmp8_[1];
		_tmp10_ = g_strdup (_tmp9_);
		ipv6 = _tmp10_;
		g_menu_remove_all (_data20_->copy_section);
		_tmp11_ = ipv4;
		if (_tmp11_ != NULL) {
			g_menu_append_item (_data20_->copy_section, _data20_->copy_ipv4);
		}
		_tmp12_ = ipv6;
		if (_tmp12_ != NULL) {
			g_menu_append_item (_data20_->copy_section, _data20_->copy_ipv6);
		}
		_tmp13_ = hamachi_get_client_id ();
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strcmp0 (_tmp14_, "") != 0;
		_g_free0 (_tmp14_);
		if (_tmp15_) {
			g_menu_append_item (_data20_->copy_section, _data20_->copy_id);
		}
		_g_free0 (ipv6);
		_g_free0 (ipv4);
		address = (_vala_array_free (address, address_length1, (GDestroyNotify) g_free), NULL);
	}
}

static void
___lambda92__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
	__lambda92_ (self);
}

static GVariant*
_variant_new5 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new6 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

Headerbar*
headerbar_construct (GType object_type)
{
	Headerbar * self = NULL;
	Block20Data* _data20_;
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
	GtkToggleButton* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkToggleButton* _tmp5_;
	GtkToggleButton* _tmp6_;
	GtkStyleContext* _tmp7_;
	GMenuItem* join = NULL;
	const gchar* _tmp8_;
	GMenuItem* _tmp9_;
	GMenuItem* create = NULL;
	const gchar* _tmp10_;
	GMenuItem* _tmp11_;
	GMenu* network_menu = NULL;
	GMenu* _tmp12_;
	GtkMenuButton* _tmp13_;
	GtkMenuButton* _tmp14_;
	GtkMenuButton* _tmp15_;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	GtkMenuButton* _tmp18_;
	const gchar* _tmp19_;
	GMenuItem* _tmp20_;
	const gchar* _tmp21_;
	GMenuItem* _tmp22_;
	const gchar* _tmp23_;
	GMenuItem* _tmp24_;
	GMenuItem* change_nick = NULL;
	const gchar* _tmp25_;
	GMenuItem* _tmp26_;
	GMenuItem* info = NULL;
	const gchar* _tmp27_;
	GMenuItem* _tmp28_;
	GMenu* info_section = NULL;
	GMenu* _tmp29_;
	GMenu* nick_section = NULL;
	GMenu* _tmp30_;
	GMenu* _tmp31_;
	GMenu* client_menu = NULL;
	GMenu* _tmp32_;
	GtkMenuButton* _tmp33_;
	GtkMenuButton* _tmp34_;
	GtkMenuButton* _tmp35_;
	GtkImage* _tmp36_;
	GtkImage* _tmp37_;
	GtkMenuButton* _tmp38_;
	GtkMenuButton* _tmp39_;
	GtkToggleButton* _tmp40_;
	GtkToggleButton* _tmp41_;
	GtkToggleButton* _tmp42_;
	GtkImage* _tmp43_;
	GtkImage* _tmp44_;
	GtkToggleButton* _tmp45_;
	GtkToggleButton* _tmp46_;
	const gchar* _tmp47_;
	GtkToggleButton* _tmp48_;
	GtkButton* _tmp49_;
	GtkButton* _tmp50_;
	GtkButton* _tmp51_;
	GtkImage* _tmp52_;
	GtkImage* _tmp53_;
	GtkButton* _tmp54_;
	GtkButton* _tmp55_;
	const gchar* _tmp56_;
	GtkButton* _tmp57_;
	GMenu* gear_menu = NULL;
	GMenu* _tmp58_;
	GMenuItem* open_config = NULL;
	const gchar* _tmp59_;
	GMenuItem* _tmp60_;
	GMenuItem* save_config = NULL;
	const gchar* _tmp61_;
	GMenuItem* _tmp62_;
	GMenuItem* restore_config = NULL;
	const gchar* _tmp63_;
	GMenuItem* _tmp64_;
	GMenuItem* sort_by_name = NULL;
	const gchar* _tmp65_;
	GMenuItem* _tmp66_;
	GVariant* _tmp67_;
	GMenuItem* sort_by_status = NULL;
	const gchar* _tmp68_;
	GMenuItem* _tmp69_;
	GVariant* _tmp70_;
	GMenuItem* show_offline = NULL;
	const gchar* _tmp71_;
	GMenuItem* _tmp72_;
	GMenuItem* preferences = NULL;
	const gchar* _tmp73_;
	GMenuItem* _tmp74_;
	GMenuItem* shortcuts = NULL;
	const gchar* _tmp75_;
	GMenuItem* _tmp76_;
	GMenuItem* help = NULL;
	const gchar* _tmp77_;
	GMenuItem* _tmp78_;
	GMenuItem* about = NULL;
	const gchar* _tmp79_;
	GMenuItem* _tmp80_;
	GMenuItem* quit = NULL;
	const gchar* _tmp81_;
	GMenuItem* _tmp82_;
	GMenu* backup_section = NULL;
	GMenu* _tmp83_;
	GMenu* open_section = NULL;
	GMenu* _tmp84_;
	GMenu* config_submenu = NULL;
	GMenu* _tmp85_;
	GMenu* sort_section = NULL;
	GMenu* _tmp86_;
	GMenu* filter_section = NULL;
	GMenu* _tmp87_;
	GMenu* meta_section = NULL;
	GMenu* _tmp88_;
	GMenu* quit_section = NULL;
	GMenu* _tmp89_;
	const gchar* _tmp90_;
	GtkMenuButton* _tmp91_;
	GtkMenuButton* _tmp92_;
	GtkMenuButton* _tmp93_;
	GtkImage* _tmp94_;
	GtkImage* _tmp95_;
	GtkMenuButton* _tmp96_;
	GtkMenuButton* _tmp97_;
	GtkAccelGroup* _tmp98_;
	GtkBox* _tmp99_;
	GtkBox* _tmp100_;
	GtkStyleContext* _tmp101_;
	GtkBox* _tmp102_;
	GtkMenuButton* _tmp103_;
	GtkBox* _tmp104_;
	GtkButton* _tmp105_;
	GtkToggleButton* _tmp106_;
	GtkMenuButton* _tmp107_;
	GtkBox* _tmp108_;
	GtkMenuButton* _tmp109_;
	GtkToggleButton* _tmp110_;
	GtkToggleButton* _tmp111_;
	gint _tmp112_ = 0;
	GtkMenuButton* _tmp113_;
	gint _tmp114_ = 0;
	GtkBox* _tmp115_;
	gint _tmp116_ = 0;
	GtkToggleButton* _tmp117_;
	gint _tmp118_ = 0;
	GtkMenuButton* _tmp119_;
	gint _tmp120_ = 0;
	gint _tmp121_ = 0;
	_data20_ = g_slice_new0 (Block20Data);
	_data20_->_ref_count_ = 1;
	self = (Headerbar*) g_object_new (object_type, NULL);
	_data20_->self = g_object_ref (self);
	gtk_header_bar_set_show_close_button ((GtkHeaderBar*) self, haguichi_window_use_header_bar);
	_tmp0_ = (GtkToggleButton*) gtk_toggle_button_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->connect_but);
	self->connect_but = _tmp0_;
	_tmp1_ = self->connect_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
	_tmp2_ = self->connect_but;
	_tmp3_ = (GtkImage*) gtk_image_new_from_icon_name ("system-shutdown-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	gtk_button_set_image ((GtkButton*) _tmp2_, (GtkWidget*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->connect_but;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp5_, "app.connect");
	_tmp6_ = self->connect_but;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "suggested-action");
	_tmp8_ = text_join_network_label;
	_tmp9_ = g_menu_item_new (_tmp8_, "app.join-network");
	join = _tmp9_;
	_tmp10_ = text_create_network_label;
	_tmp11_ = g_menu_item_new (_tmp10_, "app.create-network");
	create = _tmp11_;
	_tmp12_ = g_menu_new ();
	network_menu = _tmp12_;
	g_menu_append_item (network_menu, join);
	g_menu_append_item (network_menu, create);
	_tmp13_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->network_but);
	self->priv->network_but = _tmp13_;
	_tmp14_ = self->priv->network_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
	_tmp15_ = self->priv->network_but;
	_tmp16_ = (GtkImage*) gtk_image_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp16_);
	_tmp17_ = _tmp16_;
	gtk_button_set_image ((GtkButton*) _tmp15_, (GtkWidget*) _tmp17_);
	_g_object_unref0 (_tmp17_);
	_tmp18_ = self->priv->network_but;
	gtk_menu_button_set_menu_model (_tmp18_, (GMenuModel*) network_menu);
	_tmp19_ = text_copy_address_ipv4_label;
	_tmp20_ = g_menu_item_new (_tmp19_, "app.copy-ipv4");
	_data20_->copy_ipv4 = _tmp20_;
	_tmp21_ = text_copy_address_ipv6_label;
	_tmp22_ = g_menu_item_new (_tmp21_, "app.copy-ipv6");
	_data20_->copy_ipv6 = _tmp22_;
	_tmp23_ = text_copy_client_id_label;
	_tmp24_ = g_menu_item_new (_tmp23_, "app.copy-id");
	_data20_->copy_id = _tmp24_;
	_tmp25_ = text_change_nick_label;
	_tmp26_ = g_menu_item_new (_tmp25_, "app.change-nick");
	change_nick = _tmp26_;
	_tmp27_ = text_information_label;
	_tmp28_ = g_menu_item_new (_tmp27_, "app.info");
	info = _tmp28_;
	_tmp29_ = g_menu_new ();
	info_section = _tmp29_;
	g_menu_append_item (info_section, info);
	_tmp30_ = g_menu_new ();
	nick_section = _tmp30_;
	g_menu_append_item (nick_section, change_nick);
	_tmp31_ = g_menu_new ();
	_data20_->copy_section = _tmp31_;
	g_menu_append_item (_data20_->copy_section, _data20_->copy_ipv4);
	g_menu_append_item (_data20_->copy_section, _data20_->copy_ipv6);
	g_menu_append_item (_data20_->copy_section, _data20_->copy_id);
	_tmp32_ = g_menu_new ();
	client_menu = _tmp32_;
	g_menu_append_section (client_menu, NULL, (GMenuModel*) info_section);
	g_menu_append_section (client_menu, NULL, (GMenuModel*) nick_section);
	g_menu_append_section (client_menu, NULL, (GMenuModel*) _data20_->copy_section);
	_tmp33_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->client_but);
	self->priv->client_but = _tmp33_;
	_tmp34_ = self->priv->client_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp34_, GTK_ALIGN_CENTER);
	_tmp35_ = self->priv->client_but;
	_tmp36_ = (GtkImage*) gtk_image_new_from_icon_name ("avatar-default-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp36_);
	_tmp37_ = _tmp36_;
	gtk_button_set_image ((GtkButton*) _tmp35_, (GtkWidget*) _tmp37_);
	_g_object_unref0 (_tmp37_);
	_tmp38_ = self->priv->client_but;
	gtk_menu_button_set_menu_model (_tmp38_, (GMenuModel*) client_menu);
	_tmp39_ = self->priv->client_but;
	g_signal_connect_data ((GtkToggleButton*) _tmp39_, "toggled", (GCallback) ___lambda92__gtk_toggle_button_toggled, block20_data_ref (_data20_), (GClosureNotify) block20_data_unref, 0);
	_tmp40_ = (GtkToggleButton*) gtk_toggle_button_new ();
	g_object_ref_sink (_tmp40_);
	_g_object_unref0 (self->search_but);
	self->search_but = _tmp40_;
	_tmp41_ = self->search_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp41_, GTK_ALIGN_CENTER);
	_tmp42_ = self->search_but;
	_tmp43_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-find-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp43_);
	_tmp44_ = _tmp43_;
	gtk_button_set_image ((GtkButton*) _tmp42_, (GtkWidget*) _tmp44_);
	_g_object_unref0 (_tmp44_);
	_tmp45_ = self->search_but;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp45_, "app.start-search");
	_tmp46_ = self->search_but;
	_tmp47_ = text_search_tip;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp46_, _tmp47_);
	_tmp48_ = self->search_but;
	gtk_widget_set_has_tooltip ((GtkWidget*) _tmp48_, FALSE);
	_tmp49_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp49_);
	_g_object_unref0 (self->priv->refresh_but);
	self->priv->refresh_but = _tmp49_;
	_tmp50_ = self->priv->refresh_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp50_, GTK_ALIGN_CENTER);
	_tmp51_ = self->priv->refresh_but;
	_tmp52_ = (GtkImage*) gtk_image_new_from_icon_name ("view-refresh-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp52_);
	_tmp53_ = _tmp52_;
	gtk_button_set_image (_tmp51_, (GtkWidget*) _tmp53_);
	_g_object_unref0 (_tmp53_);
	_tmp54_ = self->priv->refresh_but;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp54_, "app.refresh");
	_tmp55_ = self->priv->refresh_but;
	_tmp56_ = text_refresh_tip;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp55_, _tmp56_);
	_tmp57_ = self->priv->refresh_but;
	gtk_widget_set_has_tooltip ((GtkWidget*) _tmp57_, FALSE);
	_tmp58_ = g_menu_new ();
	gear_menu = _tmp58_;
	_tmp59_ = text_config_folder_label;
	_tmp60_ = g_menu_item_new (_tmp59_, "app.open-config");
	open_config = _tmp60_;
	_tmp61_ = text_config_save_label;
	_tmp62_ = g_menu_item_new (_tmp61_, "app.save-config");
	save_config = _tmp62_;
	_tmp63_ = text_config_restore_label;
	_tmp64_ = g_menu_item_new (_tmp63_, "app.restore-config");
	restore_config = _tmp64_;
	_tmp65_ = text_sort_by_name;
	_tmp66_ = g_menu_item_new (_tmp65_, "app.sort-by");
	sort_by_name = _tmp66_;
	_tmp67_ = _variant_new5 ("name");
	g_menu_item_set_attribute_value (sort_by_name, "target", _tmp67_);
	_g_variant_unref0 (_tmp67_);
	_tmp68_ = text_sort_by_status;
	_tmp69_ = g_menu_item_new (_tmp68_, "app.sort-by");
	sort_by_status = _tmp69_;
	_tmp70_ = _variant_new6 ("status");
	g_menu_item_set_attribute_value (sort_by_status, "target", _tmp70_);
	_g_variant_unref0 (_tmp70_);
	_tmp71_ = text_show_offline_members;
	_tmp72_ = g_menu_item_new (_tmp71_, "app.show-offline-members");
	show_offline = _tmp72_;
	_tmp73_ = text_preferences_label;
	_tmp74_ = g_menu_item_new (_tmp73_, "app.preferences");
	preferences = _tmp74_;
	_tmp75_ = text_shortcuts_label;
	_tmp76_ = g_menu_item_new (_tmp75_, "app.shortcuts");
	shortcuts = _tmp76_;
	_tmp77_ = text_help_label;
	_tmp78_ = g_menu_item_new (_tmp77_, "app.help");
	help = _tmp78_;
	_tmp79_ = text_about_label;
	_tmp80_ = g_menu_item_new (_tmp79_, "app.about");
	about = _tmp80_;
	_tmp81_ = text_quit_label;
	_tmp82_ = g_menu_item_new (_tmp81_, "app.quit");
	quit = _tmp82_;
	_tmp83_ = g_menu_new ();
	backup_section = _tmp83_;
	g_menu_append_item (backup_section, save_config);
	g_menu_append_item (backup_section, restore_config);
	_tmp84_ = g_menu_new ();
	open_section = _tmp84_;
	g_menu_append_item (open_section, open_config);
	_tmp85_ = g_menu_new ();
	config_submenu = _tmp85_;
	g_menu_append_section (config_submenu, NULL, (GMenuModel*) backup_section);
	g_menu_append_section (config_submenu, NULL, (GMenuModel*) open_section);
	_tmp86_ = g_menu_new ();
	sort_section = _tmp86_;
	g_menu_append_item (sort_section, sort_by_name);
	g_menu_append_item (sort_section, sort_by_status);
	_tmp87_ = g_menu_new ();
	filter_section = _tmp87_;
	g_menu_append_item (filter_section, show_offline);
	_tmp88_ = g_menu_new ();
	meta_section = _tmp88_;
	g_menu_append_item (meta_section, preferences);
	g_menu_append_item (meta_section, shortcuts);
	g_menu_append_item (meta_section, help);
	g_menu_append_item (meta_section, about);
	_tmp89_ = g_menu_new ();
	quit_section = _tmp89_;
	g_menu_append_item (quit_section, quit);
	_tmp90_ = text_config_label;
	g_menu_append_submenu (gear_menu, _tmp90_, (GMenuModel*) config_submenu);
	g_menu_append_section (gear_menu, NULL, (GMenuModel*) sort_section);
	g_menu_append_section (gear_menu, NULL, (GMenuModel*) filter_section);
	g_menu_append_section (gear_menu, NULL, (GMenuModel*) meta_section);
	g_menu_append_section (gear_menu, NULL, (GMenuModel*) quit_section);
	_tmp91_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp91_);
	_g_object_unref0 (self->priv->gear_but);
	self->priv->gear_but = _tmp91_;
	_tmp92_ = self->priv->gear_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp92_, GTK_ALIGN_CENTER);
	_tmp93_ = self->priv->gear_but;
	_tmp94_ = (GtkImage*) gtk_image_new_from_icon_name ("open-menu-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp94_);
	_tmp95_ = _tmp94_;
	gtk_button_set_image ((GtkButton*) _tmp93_, (GtkWidget*) _tmp95_);
	_g_object_unref0 (_tmp95_);
	_tmp96_ = self->priv->gear_but;
	gtk_menu_button_set_menu_model (_tmp96_, (GMenuModel*) gear_menu);
	_tmp97_ = self->priv->gear_but;
	_tmp98_ = haguichi_window_accel_group;
	gtk_widget_add_accelerator ((GtkWidget*) _tmp97_, "clicked", _tmp98_, GDK_KEY_F10, 0, GTK_ACCEL_VISIBLE);
	_tmp99_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp99_);
	_g_object_unref0 (self->priv->box);
	self->priv->box = _tmp99_;
	_tmp100_ = self->priv->box;
	_tmp101_ = gtk_widget_get_style_context ((GtkWidget*) _tmp100_);
	gtk_style_context_add_class (_tmp101_, "linked");
	_tmp102_ = self->priv->box;
	_tmp103_ = self->priv->network_but;
	gtk_container_add ((GtkContainer*) _tmp102_, (GtkWidget*) _tmp103_);
	_tmp104_ = self->priv->box;
	_tmp105_ = self->priv->refresh_but;
	gtk_container_add ((GtkContainer*) _tmp104_, (GtkWidget*) _tmp105_);
	_tmp106_ = self->connect_but;
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp106_);
	_tmp107_ = self->priv->client_but;
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp107_);
	_tmp108_ = self->priv->box;
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp108_);
	_tmp109_ = self->priv->gear_but;
	gtk_header_bar_pack_end ((GtkHeaderBar*) self, (GtkWidget*) _tmp109_);
	_tmp110_ = self->search_but;
	gtk_header_bar_pack_end ((GtkHeaderBar*) self, (GtkWidget*) _tmp110_);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp111_ = self->connect_but;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp111_, &_tmp112_, NULL);
	self->priv->connect_but_width = _tmp112_;
	_tmp113_ = self->priv->client_but;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp113_, &_tmp114_, NULL);
	self->priv->client_but_width = _tmp114_;
	_tmp115_ = self->priv->box;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp115_, &_tmp116_, NULL);
	self->priv->box_width = _tmp116_;
	_tmp117_ = self->search_but;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp117_, &_tmp118_, NULL);
	self->priv->search_but_width = _tmp118_;
	_tmp119_ = self->priv->gear_but;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp119_, &_tmp120_, NULL);
	self->priv->gear_but_width = _tmp120_;
	headerbar_hide_all_buttons (self);
	gtk_widget_get_preferred_width ((GtkWidget*) self, &_tmp121_, NULL);
	self->priv->minimum_width = _tmp121_;
	_g_object_unref0 (quit_section);
	_g_object_unref0 (meta_section);
	_g_object_unref0 (filter_section);
	_g_object_unref0 (sort_section);
	_g_object_unref0 (config_submenu);
	_g_object_unref0 (open_section);
	_g_object_unref0 (backup_section);
	_g_object_unref0 (quit);
	_g_object_unref0 (about);
	_g_object_unref0 (help);
	_g_object_unref0 (shortcuts);
	_g_object_unref0 (preferences);
	_g_object_unref0 (show_offline);
	_g_object_unref0 (sort_by_status);
	_g_object_unref0 (sort_by_name);
	_g_object_unref0 (restore_config);
	_g_object_unref0 (save_config);
	_g_object_unref0 (open_config);
	_g_object_unref0 (gear_menu);
	_g_object_unref0 (client_menu);
	_g_object_unref0 (nick_section);
	_g_object_unref0 (info_section);
	_g_object_unref0 (info);
	_g_object_unref0 (change_nick);
	_g_object_unref0 (network_menu);
	_g_object_unref0 (create);
	_g_object_unref0 (join);
	block20_data_unref (_data20_);
	_data20_ = NULL;
	return self;
}

Headerbar*
headerbar_new (void)
{
	return headerbar_construct (TYPE_HEADERBAR);
}

void
headerbar_show_all_buttons (Headerbar* self)
{
	GtkToggleButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	GtkBox* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkMenuButton* _tmp4_;
	g_return_if_fail (self != NULL);
	self->priv->last_allocated = 0;
	_tmp0_ = self->connect_but;
	gtk_widget_show ((GtkWidget*) _tmp0_);
	_tmp1_ = self->priv->client_but;
	gtk_widget_show ((GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->box;
	gtk_widget_show ((GtkWidget*) _tmp2_);
	_tmp3_ = self->search_but;
	gtk_widget_show ((GtkWidget*) _tmp3_);
	_tmp4_ = self->priv->gear_but;
	gtk_widget_show ((GtkWidget*) _tmp4_);
}

void
headerbar_hide_all_buttons (Headerbar* self)
{
	GtkToggleButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	GtkBox* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkMenuButton* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->connect_but;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	_tmp1_ = self->priv->client_but;
	gtk_widget_hide ((GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->box;
	gtk_widget_hide ((GtkWidget*) _tmp2_);
	_tmp3_ = self->search_but;
	gtk_widget_hide ((GtkWidget*) _tmp3_);
	_tmp4_ = self->priv->gear_but;
	gtk_widget_hide ((GtkWidget*) _tmp4_);
}

void
headerbar_show_hide_buttons (Headerbar* self,
                             gint allocated,
                             gint minimum)
{
	gint current = 0;
	GtkToggleButton* _tmp0_;
	g_return_if_fail (self != NULL);
	if (allocated == self->priv->last_allocated) {
		return;
	}
	self->priv->last_allocated = allocated;
	headerbar_hide_all_buttons (self);
	current = minimum + self->priv->connect_but_width;
	_tmp0_ = self->connect_but;
	gtk_widget_show ((GtkWidget*) _tmp0_);
	current += self->priv->gear_but_width;
	if (allocated > current) {
		GtkMenuButton* _tmp1_;
		_tmp1_ = self->priv->gear_but;
		gtk_widget_show ((GtkWidget*) _tmp1_);
	}
	current += self->priv->client_but_width;
	if (allocated > current) {
		GtkMenuButton* _tmp2_;
		_tmp2_ = self->priv->client_but;
		gtk_widget_show ((GtkWidget*) _tmp2_);
	}
	current += self->priv->search_but_width;
	if (allocated > current) {
		GtkToggleButton* _tmp3_;
		_tmp3_ = self->search_but;
		gtk_widget_show ((GtkWidget*) _tmp3_);
	}
	current += self->priv->box_width;
	if (allocated > current) {
		GtkBox* _tmp4_;
		_tmp4_ = self->priv->box;
		gtk_widget_show ((GtkWidget*) _tmp4_);
	}
}

static void
headerbar_real_get_preferred_width (GtkWidget* base,
                                    gint* new_minimum_width,
                                    gint* new_natural_width)
{
	Headerbar * self;
	gint _vala_new_minimum_width = 0;
	gint _vala_new_natural_width = 0;
	gboolean _tmp0_ = FALSE;
	self = (Headerbar*) base;
	if (haguichi_window_use_header_bar == FALSE) {
		_tmp0_ = self->priv->minimum_width > 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
	} else {
		if (haguichi_window_minimum_width > 0) {
			const gchar* _tmp1_;
			self->priv->minimum_width = haguichi_window_minimum_width;
			_tmp1_ = gtk_check_version ((guint) 3, (guint) 18, (guint) 0);
			if (_tmp1_ == NULL) {
				self->priv->minimum_width = self->priv->minimum_width + 50;
			}
		} else {
			gint base_minimum_width = 0;
			gint base_natural_width = 0;
			gint _tmp2_ = 0;
			gint _tmp3_ = 0;
			GTK_WIDGET_CLASS (headerbar_parent_class)->get_preferred_width ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_header_bar_get_type (), GtkHeaderBar), &_tmp2_, &_tmp3_);
			base_minimum_width = _tmp2_;
			base_natural_width = _tmp3_;
			self->priv->minimum_width = base_minimum_width;
		}
	}
	_vala_new_minimum_width = self->priv->minimum_width;
	_vala_new_natural_width = self->priv->minimum_width;
	if (new_minimum_width) {
		*new_minimum_width = _vala_new_minimum_width;
	}
	if (new_natural_width) {
		*new_natural_width = _vala_new_natural_width;
	}
}

void
headerbar_set_mode (Headerbar* self,
                    const gchar* _mode)
{
	gchar* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GtkMenuButton* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GQuark _tmp12_ = 0U;
	static GQuark _tmp11_label0 = 0;
	static GQuark _tmp11_label1 = 0;
	static GQuark _tmp11_label2 = 0;
	static GQuark _tmp11_label3 = 0;
	static GQuark _tmp11_label4 = 0;
	static GQuark _tmp11_label5 = 0;
	static GQuark _tmp11_label6 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_mode != NULL);
	_tmp0_ = g_strdup (_mode);
	_g_free0 (self->priv->mode);
	self->priv->mode = _tmp0_;
	_tmp1_ = global_actions_connect;
	g_simple_action_set_enabled (_tmp1_, FALSE);
	_tmp2_ = global_actions_disconnect;
	g_simple_action_set_enabled (_tmp2_, FALSE);
	_tmp3_ = global_actions_info;
	g_simple_action_set_enabled (_tmp3_, FALSE);
	_tmp4_ = global_actions_join_network;
	g_simple_action_set_enabled (_tmp4_, FALSE);
	_tmp5_ = global_actions_create_network;
	g_simple_action_set_enabled (_tmp5_, FALSE);
	_tmp6_ = global_actions_refresh;
	g_simple_action_set_enabled (_tmp6_, FALSE);
	_tmp7_ = global_actions_start_search;
	g_simple_action_set_enabled (_tmp7_, FALSE);
	_tmp8_ = self->priv->network_but;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
	_tmp9_ = self->priv->mode;
	_tmp10_ = _tmp9_;
	_tmp12_ = (NULL == _tmp10_) ? 0 : g_quark_from_string (_tmp10_);
	if (_tmp12_ == ((0 != _tmp11_label0) ? _tmp11_label0 : (_tmp11_label0 = g_quark_from_static_string ("Initializing")))) {
		switch (0) {
			default:
			{
				const gchar* _tmp13_;
				_tmp13_ = text_initializing;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp13_);
				break;
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label1) ? _tmp11_label1 : (_tmp11_label1 = g_quark_from_static_string ("Countdown")))) {
		switch (0) {
			default:
			{
				GSimpleAction* _tmp14_;
				GSimpleAction* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				_tmp14_ = global_actions_connect;
				g_simple_action_set_enabled (_tmp14_, TRUE);
				_tmp15_ = global_actions_info;
				g_simple_action_set_enabled (_tmp15_, TRUE);
				_tmp16_ = text_reconnecting (controller_restore_countdown);
				_tmp17_ = g_strdup_printf ("%i", controller_restore_countdown);
				_tmp18_ = _tmp17_;
				_tmp19_ = utils_format (_tmp16_, _tmp18_, NULL, NULL);
				_tmp20_ = _tmp19_;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp20_);
				_g_free0 (_tmp20_);
				_g_free0 (_tmp18_);
				break;
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label2) ? _tmp11_label2 : (_tmp11_label2 = g_quark_from_static_string ("Connecting")))) {
		switch (0) {
			default:
			{
				GtkToggleButton* _tmp21_;
				GSimpleAction* _tmp22_;
				const gchar* _tmp23_;
				_tmp21_ = self->connect_but;
				gtk_toggle_button_set_active (_tmp21_, TRUE);
				_tmp22_ = global_actions_info;
				g_simple_action_set_enabled (_tmp22_, TRUE);
				_tmp23_ = text_connecting;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp23_);
				break;
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label3) ? _tmp11_label3 : (_tmp11_label3 = g_quark_from_static_string ("Connected")))) {
		switch (0) {
			default:
			{
				GtkToggleButton* _tmp24_;
				const gchar* _tmp25_;
				GtkToggleButton* _tmp26_;
				GtkToggleButton* _tmp27_;
				GtkToggleButton* _tmp28_;
				GSimpleAction* _tmp29_;
				GSimpleAction* _tmp30_;
				GSimpleAction* _tmp31_;
				GSimpleAction* _tmp32_;
				GSimpleAction* _tmp33_;
				GSimpleAction* _tmp34_;
				GtkMenuButton* _tmp35_;
				const gchar* _tmp36_;
				_tmp24_ = self->connect_but;
				_tmp25_ = text_disconnect_tip;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp24_, _tmp25_);
				_tmp26_ = self->connect_but;
				gtk_widget_set_has_tooltip ((GtkWidget*) _tmp26_, FALSE);
				_tmp27_ = self->connect_but;
				gtk_actionable_set_action_name ((GtkActionable*) _tmp27_, "app.disconnect");
				_tmp28_ = self->connect_but;
				gtk_toggle_button_set_active (_tmp28_, TRUE);
				_tmp29_ = global_actions_disconnect;
				g_simple_action_set_enabled (_tmp29_, TRUE);
				_tmp30_ = global_actions_info;
				g_simple_action_set_enabled (_tmp30_, TRUE);
				_tmp31_ = global_actions_join_network;
				g_simple_action_set_enabled (_tmp31_, TRUE);
				_tmp32_ = global_actions_create_network;
				g_simple_action_set_enabled (_tmp32_, TRUE);
				_tmp33_ = global_actions_refresh;
				g_simple_action_set_enabled (_tmp33_, TRUE);
				_tmp34_ = global_actions_start_search;
				g_simple_action_set_enabled (_tmp34_, TRUE);
				_tmp35_ = self->priv->network_but;
				gtk_widget_set_sensitive ((GtkWidget*) _tmp35_, TRUE);
				_tmp36_ = text_connected;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp36_);
				break;
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label4) ? _tmp11_label4 : (_tmp11_label4 = g_quark_from_static_string ("Disconnected")))) {
		switch (0) {
			default:
			{
				GtkToggleButton* _tmp37_;
				const gchar* _tmp38_;
				GtkToggleButton* _tmp39_;
				GtkToggleButton* _tmp40_;
				GtkToggleButton* _tmp41_;
				GSimpleAction* _tmp42_;
				GSimpleAction* _tmp43_;
				const gchar* _tmp44_;
				_tmp37_ = self->connect_but;
				_tmp38_ = text_connect_tip;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp37_, _tmp38_);
				_tmp39_ = self->connect_but;
				gtk_widget_set_has_tooltip ((GtkWidget*) _tmp39_, FALSE);
				_tmp40_ = self->connect_but;
				gtk_actionable_set_action_name ((GtkActionable*) _tmp40_, "app.connect");
				_tmp41_ = self->connect_but;
				gtk_toggle_button_set_active (_tmp41_, FALSE);
				_tmp42_ = global_actions_connect;
				g_simple_action_set_enabled (_tmp42_, TRUE);
				_tmp43_ = global_actions_info;
				g_simple_action_set_enabled (_tmp43_, TRUE);
				global_events_stop_search ();
				_tmp44_ = text_disconnected;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp44_);
				break;
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label5) ? _tmp11_label5 : (_tmp11_label5 = g_quark_from_static_string ("Not configured")))) {
		switch (0) {
			default:
			{
				GtkToggleButton* _tmp45_;
				GSimpleAction* _tmp46_;
				const gchar* _tmp47_;
				_tmp45_ = self->connect_but;
				gtk_toggle_button_set_active (_tmp45_, FALSE);
				_tmp46_ = global_actions_refresh;
				g_simple_action_set_enabled (_tmp46_, TRUE);
				_tmp47_ = text_disconnected;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp47_);
				break;
			}
		}
	} else if (_tmp12_ == ((0 != _tmp11_label6) ? _tmp11_label6 : (_tmp11_label6 = g_quark_from_static_string ("Not installed")))) {
		switch (0) {
			default:
			{
				GtkToggleButton* _tmp48_;
				GSimpleAction* _tmp49_;
				const gchar* _tmp50_;
				_tmp48_ = self->connect_but;
				gtk_toggle_button_set_active (_tmp48_, FALSE);
				_tmp49_ = global_actions_refresh;
				g_simple_action_set_enabled (_tmp49_, TRUE);
				_tmp50_ = text_disconnected;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp50_);
				break;
			}
		}
	}
}

static void
headerbar_class_init (HeaderbarClass * klass,
                      gpointer klass_data)
{
	headerbar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Headerbar_private_offset);
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) headerbar_real_get_preferred_width;
	G_OBJECT_CLASS (klass)->finalize = headerbar_finalize;
}

static void
headerbar_instance_init (Headerbar * self,
                         gpointer klass)
{
	self->priv = headerbar_get_instance_private (self);
}

static void
headerbar_finalize (GObject * obj)
{
	Headerbar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HEADERBAR, Headerbar);
	_g_free0 (self->priv->mode);
	_g_object_unref0 (self->connect_but);
	_g_object_unref0 (self->priv->network_but);
	_g_object_unref0 (self->priv->client_but);
	_g_object_unref0 (self->search_but);
	_g_object_unref0 (self->priv->refresh_but);
	_g_object_unref0 (self->priv->gear_but);
	_g_object_unref0 (self->priv->box);
	G_OBJECT_CLASS (headerbar_parent_class)->finalize (obj);
}

static GType
headerbar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeaderbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) headerbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Headerbar), 0, (GInstanceInitFunc) headerbar_instance_init, NULL };
	GType headerbar_type_id;
	headerbar_type_id = g_type_register_static (gtk_header_bar_get_type (), "Headerbar", &g_define_type_info, 0);
	Headerbar_private_offset = g_type_add_instance_private (headerbar_type_id, sizeof (HeaderbarPrivate));
	return headerbar_type_id;
}

GType
headerbar_get_type (void)
{
	static volatile gsize headerbar_type_id__volatile = 0;
	if (g_once_init_enter (&headerbar_type_id__volatile)) {
		GType headerbar_type_id;
		headerbar_type_id = headerbar_get_type_once ();
		g_once_init_leave (&headerbar_type_id__volatile, headerbar_type_id);
	}
	return headerbar_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

