/* inhibitor.c generated by valac 0.54.6, the Vala compiler
 * generated from inhibitor.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2020 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gunixinputstream.h>
#include <gio/gunixfdlist.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_LOGIND_MANAGER (logind_manager_get_type ())
#define LOGIND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIND_MANAGER, LogindManager))
#define IS_LOGIND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIND_MANAGER))
#define LOGIND_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIND_MANAGER, LogindManagerIface))

typedef struct _LogindManager LogindManager;
typedef struct _LogindManagerIface LogindManagerIface;

#define TYPE_LOGIND_MANAGER_PROXY (logind_manager_proxy_get_type ())
enum  {
	LOGIND_MANAGER_PREPARE_FOR_SLEEP_SIGNAL,
	LOGIND_MANAGER_NUM_SIGNALS
};
static guint logind_manager_signals[LOGIND_MANAGER_NUM_SIGNALS] = {0};
typedef GDBusProxy LogindManagerProxy;
typedef GDBusProxyClass LogindManagerProxyClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_INHIBITOR (inhibitor_get_type ())
#define INHIBITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INHIBITOR, Inhibitor))
#define INHIBITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INHIBITOR, InhibitorClass))
#define IS_INHIBITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INHIBITOR))
#define IS_INHIBITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INHIBITOR))
#define INHIBITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INHIBITOR, InhibitorClass))

typedef struct _Inhibitor Inhibitor;
typedef struct _InhibitorClass InhibitorClass;
typedef struct _InhibitorPrivate InhibitorPrivate;
enum  {
	INHIBITOR_0_PROPERTY,
	INHIBITOR_NUM_PROPERTIES
};
static GParamSpec* inhibitor_properties[INHIBITOR_NUM_PROPERTIES];
typedef enum  {
	DEBUG_DOMAIN_ERROR,
	DEBUG_DOMAIN_INFO,
	DEBUG_DOMAIN_HAMACHI,
	DEBUG_DOMAIN_ENVIRONMENT,
	DEBUG_DOMAIN_GUI
} Debugdomain;

#define DEBUG_TYPE_DOMAIN (debug_domain_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _LogindManagerIface {
	GTypeInterface parent_iface;
	GUnixInputStream* (*inhibit) (LogindManager* self, const gchar* what, const gchar* who, const gchar* why, const gchar* mode, GError** error);
};

struct _Inhibitor {
	GObject parent_instance;
	InhibitorPrivate * priv;
};

struct _InhibitorClass {
	GObjectClass parent_class;
};

struct _InhibitorPrivate {
	LogindManager* manager;
	GUnixInputStream* lock_file;
};

static gint Inhibitor_private_offset;
static gpointer inhibitor_parent_class = NULL;
VALA_EXTERN gboolean controller_restore;
VALA_EXTERN gint controller_last_status;
VALA_EXTERN gint controller_restore_countdown;

VALA_EXTERN GType logind_manager_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint logind_manager_register_object (void* object,
                                      GDBusConnection* connection,
                                      const gchar* path,
                                      GError** error);
VALA_EXTERN GType logind_manager_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GUnixInputStream* logind_manager_inhibit (LogindManager* self,
                                          const gchar* what,
                                          const gchar* who,
                                          const gchar* why,
                                          const gchar* mode,
                                          GError** error);
static GType logind_manager_get_type_once (void);
static void logind_manager_proxy_g_signal (GDBusProxy* proxy,
                                    const gchar* sender_name,
                                    const gchar* signal_name,
                                    GVariant* parameters);
static void _dbus_handle_logind_manager_prepare_for_sleep (LogindManager* self,
                                                    GVariant* parameters);
static GUnixInputStream* logind_manager_proxy_inhibit (LogindManager* self,
                                                const gchar* what,
                                                const gchar* who,
                                                const gchar* why,
                                                const gchar* mode,
                                                GError** error);
static void logind_manager_proxy_logind_manager_interface_init (LogindManagerIface* iface);
static void _dbus_logind_manager_inhibit (LogindManager* self,
                                   GVariant* _parameters_,
                                   GDBusMethodInvocation* invocation);
static void logind_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* method_name,
                                                GVariant* parameters,
                                                GDBusMethodInvocation* invocation,
                                                gpointer user_data);
static GVariant* logind_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GError** error,
                                                      gpointer user_data);
static gboolean logind_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GVariant* value,
                                                     GError** error,
                                                     gpointer user_data);
static void _dbus_logind_manager_prepare_for_sleep (GObject* _sender,
                                             gboolean before,
                                             gpointer* _data);
static void _logind_manager_unregister_object (gpointer user_data);
VALA_EXTERN GType inhibitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Inhibitor, g_object_unref)
VALA_EXTERN Inhibitor* inhibitor_new (void);
VALA_EXTERN Inhibitor* inhibitor_construct (GType object_type);
VALA_EXTERN GType debug_domain_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void debug_log (Debugdomain _domain,
                const gchar* reporter,
                const gchar* output);
static void __lambda98_ (Inhibitor* self,
                  gboolean before);
VALA_EXTERN void global_events_connection_stopped (void);
VALA_EXTERN gchar* hamachi_logout (void);
VALA_EXTERN void inhibitor_release (Inhibitor* self);
VALA_EXTERN void controller_wait_for_internet_cycle (void);
VALA_EXTERN void inhibitor_aquire (Inhibitor* self);
static void ___lambda98__logind_manager_prepare_for_sleep (LogindManager* _sender,
                                                    gboolean before,
                                                    gpointer self);
static void inhibitor_finalize (GObject * obj);
static GType inhibitor_get_type_once (void);

static const GDBusArgInfo _logind_manager_dbus_arg_info_inhibit_what = {-1, "what", "s", NULL};
static const GDBusArgInfo _logind_manager_dbus_arg_info_inhibit_who = {-1, "who", "s", NULL};
static const GDBusArgInfo _logind_manager_dbus_arg_info_inhibit_why = {-1, "why", "s", NULL};
static const GDBusArgInfo _logind_manager_dbus_arg_info_inhibit_mode = {-1, "mode", "s", NULL};
static const GDBusArgInfo _logind_manager_dbus_arg_info_inhibit_result = {-1, "result", "h", NULL};
static const GDBusArgInfo * const _logind_manager_dbus_arg_info_inhibit_in[] = {&_logind_manager_dbus_arg_info_inhibit_what, &_logind_manager_dbus_arg_info_inhibit_who, &_logind_manager_dbus_arg_info_inhibit_why, &_logind_manager_dbus_arg_info_inhibit_mode, NULL};
static const GDBusArgInfo * const _logind_manager_dbus_arg_info_inhibit_out[] = {&_logind_manager_dbus_arg_info_inhibit_result, NULL};
static const GDBusMethodInfo _logind_manager_dbus_method_info_inhibit = {-1, "Inhibit", (GDBusArgInfo **) (&_logind_manager_dbus_arg_info_inhibit_in), (GDBusArgInfo **) (&_logind_manager_dbus_arg_info_inhibit_out), NULL};
static const GDBusMethodInfo * const _logind_manager_dbus_method_info[] = {&_logind_manager_dbus_method_info_inhibit, NULL};
static const GDBusArgInfo _logind_manager_dbus_arg_info_prepare_for_sleep_before = {-1, "before", "b", NULL};
static const GDBusArgInfo * const _logind_manager_dbus_arg_info_prepare_for_sleep[] = {&_logind_manager_dbus_arg_info_prepare_for_sleep_before, NULL};
static const GDBusSignalInfo _logind_manager_dbus_signal_info_prepare_for_sleep = {-1, "PrepareForSleep", (GDBusArgInfo **) (&_logind_manager_dbus_arg_info_prepare_for_sleep), NULL};
static const GDBusSignalInfo * const _logind_manager_dbus_signal_info[] = {&_logind_manager_dbus_signal_info_prepare_for_sleep, NULL};
static const GDBusPropertyInfo * const _logind_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _logind_manager_dbus_interface_info = {-1, "org.freedesktop.login1.Manager", (GDBusMethodInfo **) (&_logind_manager_dbus_method_info), (GDBusSignalInfo **) (&_logind_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_logind_manager_dbus_property_info), NULL};
static const GDBusInterfaceVTable _logind_manager_dbus_interface_vtable = {logind_manager_dbus_interface_method_call, logind_manager_dbus_interface_get_property, logind_manager_dbus_interface_set_property};

GUnixInputStream*
logind_manager_inhibit (LogindManager* self,
                        const gchar* what,
                        const gchar* who,
                        const gchar* why,
                        const gchar* mode,
                        GError** error)
{
	LogindManagerIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = LOGIND_MANAGER_GET_INTERFACE (self);
	if (_iface_->inhibit) {
		return _iface_->inhibit (self, what, who, why, mode, error);
	}
	return NULL;
}

static void
logind_manager_default_init (LogindManagerIface * iface,
                             gpointer iface_data)
{
	logind_manager_signals[LOGIND_MANAGER_PREPARE_FOR_SLEEP_SIGNAL] = g_signal_new ("prepare-for-sleep", TYPE_LOGIND_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}

static GType
logind_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LogindManagerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) logind_manager_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType logind_manager_type_id;
	logind_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "LogindManager", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (logind_manager_type_id, g_dbus_proxy_get_type ());
	g_type_set_qdata (logind_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) logind_manager_proxy_get_type);
	g_type_set_qdata (logind_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.login1.Manager");
	g_type_set_qdata (logind_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_logind_manager_dbus_interface_info));
	g_type_set_qdata (logind_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) logind_manager_register_object);
	return logind_manager_type_id;
}

GType
logind_manager_get_type (void)
{
	static volatile gsize logind_manager_type_id__volatile = 0;
	if (g_once_init_enter (&logind_manager_type_id__volatile)) {
		GType logind_manager_type_id;
		logind_manager_type_id = logind_manager_get_type_once ();
		g_once_init_leave (&logind_manager_type_id__volatile, logind_manager_type_id);
	}
	return logind_manager_type_id__volatile;
}

G_DEFINE_TYPE_EXTENDED (LogindManagerProxy, logind_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_LOGIND_MANAGER, logind_manager_proxy_logind_manager_interface_init) )
static void
logind_manager_proxy_class_init (LogindManagerProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = logind_manager_proxy_g_signal;
}

static void
_dbus_handle_logind_manager_prepare_for_sleep (LogindManager* self,
                                               GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gboolean before = FALSE;
	GVariant* _tmp0_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	before = g_variant_get_boolean (_tmp0_);
	g_variant_unref (_tmp0_);
	g_signal_emit_by_name (self, "prepare-for-sleep", before);
}

static void
logind_manager_proxy_g_signal (GDBusProxy* proxy,
                               const gchar* sender_name,
                               const gchar* signal_name,
                               GVariant* parameters)
{
	if (strcmp (signal_name, "PrepareForSleep") == 0) {
		_dbus_handle_logind_manager_prepare_for_sleep ((LogindManager*) proxy, parameters);
	}
}

static void
logind_manager_proxy_init (LogindManagerProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_logind_manager_dbus_interface_info));
}

static GUnixInputStream*
logind_manager_proxy_inhibit (LogindManager* self,
                              const gchar* what,
                              const gchar* who,
                              const gchar* why,
                              const gchar* mode,
                              GError** error)
{
	GUnixFDList* _fd_list;
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	gint _fd_index = 0;
	gint _fd;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GUnixInputStream* _result = NULL;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "Inhibit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_fd_list = g_unix_fd_list_new ();
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (what));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (who));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (why));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (mode));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_message_set_unix_fd_list (_message, _fd_list);
	g_object_unref (_fd_list);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_fd_list = g_dbus_message_get_unix_fd_list (_reply_message);
	if (_fd_list) {
		g_variant_iter_next (&_reply_iter, "h", &_fd_index);
		_fd = g_unix_fd_list_get (_fd_list, _fd_index, error);
		if (_fd >= 0) {
			_result = (GUnixInputStream *) g_unix_input_stream_new (_fd, TRUE);
		}
	} else {
		g_set_error_literal (error, G_IO_ERROR, G_IO_ERROR_FAILED, "FD List is NULL");
	}
	if (error && (*error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	g_object_unref (_reply_message);
	return _result;
}

static void
logind_manager_proxy_logind_manager_interface_init (LogindManagerIface* iface)
{
	iface->inhibit = logind_manager_proxy_inhibit;
}

static void
_dbus_logind_manager_inhibit (LogindManager* self,
                              GVariant* _parameters_,
                              GDBusMethodInvocation* invocation)
{
	GUnixFDList* _fd_list;
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint _fd_index = 0;
	gint _fd;
	gchar* what = NULL;
	GVariant* _tmp1_;
	gchar* who = NULL;
	GVariant* _tmp2_;
	gchar* why = NULL;
	GVariant* _tmp3_;
	gchar* mode = NULL;
	GVariant* _tmp4_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GUnixInputStream* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	what = g_variant_dup_string (_tmp1_, NULL);
	g_variant_unref (_tmp1_);
	_tmp2_ = g_variant_iter_next_value (&_arguments_iter);
	who = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	why = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	_tmp4_ = g_variant_iter_next_value (&_arguments_iter);
	mode = g_variant_dup_string (_tmp4_, NULL);
	g_variant_unref (_tmp4_);
	result = logind_manager_inhibit (self, what, who, why, mode, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_fd_list = g_unix_fd_list_new ();
	g_variant_builder_add (&_reply_builder, "h", g_unix_fd_list_append (_fd_list, g_unix_input_stream_get_fd (result), NULL));
	_g_object_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_message_set_unix_fd_list (_reply_message, _fd_list);
	g_object_unref (_fd_list);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (what);
	_g_free0 (who);
	_g_free0 (why);
	_g_free0 (mode);
	;
}

static void
logind_manager_dbus_interface_method_call (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* method_name,
                                           GVariant* parameters,
                                           GDBusMethodInvocation* invocation,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Inhibit") == 0) {
		_dbus_logind_manager_inhibit (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
logind_manager_dbus_interface_get_property (GDBusConnection* connection,
                                            const gchar* sender,
                                            const gchar* object_path,
                                            const gchar* interface_name,
                                            const gchar* property_name,
                                            GError** error,
                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
logind_manager_dbus_interface_set_property (GDBusConnection* connection,
                                            const gchar* sender,
                                            const gchar* object_path,
                                            const gchar* interface_name,
                                            const gchar* property_name,
                                            GVariant* value,
                                            GError** error,
                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_logind_manager_prepare_for_sleep (GObject* _sender,
                                        gboolean before,
                                        gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (before));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.login1.Manager", "PrepareForSleep", _arguments, NULL);
}

guint
logind_manager_register_object (gpointer object,
                                GDBusConnection* connection,
                                const gchar* path,
                                GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_logind_manager_dbus_interface_info), &_logind_manager_dbus_interface_vtable, data, _logind_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "prepare-for-sleep", (GCallback) _dbus_logind_manager_prepare_for_sleep, data);
	return result;
}

static void
_logind_manager_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_logind_manager_prepare_for_sleep, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
inhibitor_get_instance_private (Inhibitor* self)
{
	return G_STRUCT_MEMBER_P (self, Inhibitor_private_offset);
}

static void
__lambda98_ (Inhibitor* self,
             gboolean before)
{
	if (before) {
		gboolean _tmp0_ = FALSE;
		debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Inhibitor.manager", "Preparing for sleep...");
		if (controller_restore) {
			_tmp0_ = TRUE;
		} else {
			_tmp0_ = controller_last_status >= 6;
		}
		if (_tmp0_) {
			gchar* _tmp1_;
			gchar* _tmp2_;
			controller_restore_countdown = 0;
			controller_restore = FALSE;
			global_events_connection_stopped ();
			_tmp1_ = hamachi_logout ();
			_tmp2_ = _tmp1_;
			_g_free0 (_tmp2_);
			controller_restore = TRUE;
		}
		inhibitor_release (self);
	} else {
		debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Inhibitor.manager", "Waking up...");
		if (controller_restore) {
			controller_wait_for_internet_cycle ();
		}
		inhibitor_aquire (self);
	}
}

static void
___lambda98__logind_manager_prepare_for_sleep (LogindManager* _sender,
                                               gboolean before,
                                               gpointer self)
{
	__lambda98_ ((Inhibitor*) self, before);
}

Inhibitor*
inhibitor_construct (GType object_type)
{
	Inhibitor * self = NULL;
	LogindManager* _tmp5_;
	GError* _inner_error0_ = NULL;
	self = (Inhibitor*) g_object_new (object_type, NULL);
	{
		LogindManager* _tmp0_ = NULL;
		LogindManager* _tmp1_;
		LogindManager* _tmp2_;
		_tmp1_ = (LogindManager*) g_initable_new (TYPE_LOGIND_MANAGER_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.login1", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/org/freedesktop/login1", "g-interface-name", "org.freedesktop.login1.Manager", NULL);
		_tmp0_ = (LogindManager*) _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->manager);
		self->priv->manager = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		debug_log (DEBUG_DOMAIN_ERROR, "Inhibitor.manager", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp5_ = self->priv->manager;
	g_signal_connect_object (_tmp5_, "prepare-for-sleep", (GCallback) ___lambda98__logind_manager_prepare_for_sleep, self, 0);
	inhibitor_aquire (self);
	return self;
}

Inhibitor*
inhibitor_new (void)
{
	return inhibitor_construct (TYPE_INHIBITOR);
}

void
inhibitor_release (Inhibitor* self)
{
	GUnixInputStream* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Inhibitor.release", "Releasing inhibit lock.");
	_tmp0_ = self->priv->lock_file;
	if (_tmp0_ != NULL) {
		{
			GUnixInputStream* _tmp1_;
			_tmp1_ = self->priv->lock_file;
			g_input_stream_close ((GInputStream*) _tmp1_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_IO_ERROR) {
					goto __catch0_g_io_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp2_ = e;
			_tmp3_ = _tmp2_->message;
			debug_log (DEBUG_DOMAIN_ERROR, "Inhibitor.release", _tmp3_);
			_g_error_free0 (e);
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			_g_object_unref0 (self->priv->lock_file);
			self->priv->lock_file = NULL;
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

void
inhibitor_aquire (Inhibitor* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Inhibitor.aquire", "Acquiring inhibit lock.");
	{
		GUnixInputStream* _tmp0_ = NULL;
		LogindManager* _tmp1_;
		GUnixInputStream* _tmp2_;
		GUnixInputStream* _tmp3_;
		_tmp1_ = self->priv->manager;
		_tmp2_ = logind_manager_inhibit (_tmp1_, "sleep", "Haguichi", "Properly disconnect", "delay", &_inner_error0_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->lock_file);
		self->priv->lock_file = _tmp3_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		debug_log (DEBUG_DOMAIN_ERROR, "Inhibitor.aquire", _tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
inhibitor_class_init (InhibitorClass * klass,
                      gpointer klass_data)
{
	inhibitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Inhibitor_private_offset);
	G_OBJECT_CLASS (klass)->finalize = inhibitor_finalize;
}

static void
inhibitor_instance_init (Inhibitor * self,
                         gpointer klass)
{
	self->priv = inhibitor_get_instance_private (self);
	self->priv->lock_file = NULL;
}

static void
inhibitor_finalize (GObject * obj)
{
	Inhibitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INHIBITOR, Inhibitor);
	_g_object_unref0 (self->priv->manager);
	_g_object_unref0 (self->priv->lock_file);
	G_OBJECT_CLASS (inhibitor_parent_class)->finalize (obj);
}

static GType
inhibitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (InhibitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) inhibitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Inhibitor), 0, (GInstanceInitFunc) inhibitor_instance_init, NULL };
	GType inhibitor_type_id;
	inhibitor_type_id = g_type_register_static (G_TYPE_OBJECT, "Inhibitor", &g_define_type_info, 0);
	Inhibitor_private_offset = g_type_add_instance_private (inhibitor_type_id, sizeof (InhibitorPrivate));
	return inhibitor_type_id;
}

GType
inhibitor_get_type (void)
{
	static volatile gsize inhibitor_type_id__volatile = 0;
	if (g_once_init_enter (&inhibitor_type_id__volatile)) {
		GType inhibitor_type_id;
		inhibitor_type_id = inhibitor_get_type_once ();
		g_once_init_leave (&inhibitor_type_id__volatile, inhibitor_type_id);
	}
	return inhibitor_type_id__volatile;
}

