/* network-menu.c generated by valac 0.54.6, the Vala compiler
 * generated from network-menu.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2020 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MENUS_TYPE_NETWORK_MENU (menus_network_menu_get_type ())
#define MENUS_NETWORK_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MENUS_TYPE_NETWORK_MENU, MenusNetworkMenu))
#define MENUS_NETWORK_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MENUS_TYPE_NETWORK_MENU, MenusNetworkMenuClass))
#define MENUS_IS_NETWORK_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MENUS_TYPE_NETWORK_MENU))
#define MENUS_IS_NETWORK_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MENUS_TYPE_NETWORK_MENU))
#define MENUS_NETWORK_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MENUS_TYPE_NETWORK_MENU, MenusNetworkMenuClass))

typedef struct _MenusNetworkMenu MenusNetworkMenu;
typedef struct _MenusNetworkMenuClass MenusNetworkMenuClass;
typedef struct _MenusNetworkMenuPrivate MenusNetworkMenuPrivate;

#define TYPE_NETWORK (network_get_type ())
#define NETWORK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NETWORK, Network))
#define NETWORK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NETWORK, NetworkClass))
#define IS_NETWORK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NETWORK))
#define IS_NETWORK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NETWORK))
#define NETWORK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NETWORK, NetworkClass))

typedef struct _Network Network;
typedef struct _NetworkClass NetworkClass;
enum  {
	MENUS_NETWORK_MENU_0_PROPERTY,
	MENUS_NETWORK_MENU_NUM_PROPERTIES
};
static GParamSpec* menus_network_menu_properties[MENUS_NETWORK_MENU_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _NetworkPrivate NetworkPrivate;

#define TYPE_STATUS (status_get_type ())
#define STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS, Status))
#define STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS, StatusClass))
#define IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS))
#define IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS))
#define STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS, StatusClass))

typedef struct _Status Status;
typedef struct _StatusClass StatusClass;

#define TYPE_MEMBER (member_get_type ())
#define MEMBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEMBER, Member))
#define MEMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEMBER, MemberClass))
#define IS_MEMBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEMBER))
#define IS_MEMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEMBER))
#define MEMBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEMBER, MemberClass))

typedef struct _Member Member;
typedef struct _MemberClass MemberClass;
typedef struct _StatusPrivate StatusPrivate;

struct _MenusNetworkMenu {
	GtkMenu parent_instance;
	MenusNetworkMenuPrivate * priv;
};

struct _MenusNetworkMenuClass {
	GtkMenuClass parent_class;
};

struct _MenusNetworkMenuPrivate {
	Network* network;
	GtkMenuItem* go_online_item;
	GtkMenuItem* go_offline_item;
	GtkMenuItem* leave_item;
	GtkMenuItem* delete_item;
	GtkSeparatorMenuItem* separator1;
	GtkCheckMenuItem* locked_item;
	GtkMenuItem* approve_item;
	GtkMenuItem* password_item;
	GtkMenu* approve_menu;
	GtkRadioMenuItem* auto_item;
	GtkRadioMenuItem* manual_item;
	GtkSeparatorMenuItem* separator2;
	GtkMenuItem* copy_item;
};

struct _Network {
	GObject parent_instance;
	NetworkPrivate * priv;
	Status* status;
	gchar* id;
	gchar* name;
	GList* members;
	gint is_owner;
	gchar* owner;
	gchar* lock_state;
	gchar* approve;
	gint capacity;
	gchar* name_sort_string;
	gchar* status_sort_string;
};

struct _NetworkClass {
	GObjectClass parent_class;
};

struct _Status {
	GObject parent_instance;
	StatusPrivate * priv;
	gint status_int;
	gchar* status_text;
	gchar* status_sortable;
	gchar* message;
	gchar* connection_type;
};

struct _StatusClass {
	GObjectClass parent_class;
};

static gint MenusNetworkMenu_private_offset;
static gpointer menus_network_menu_parent_class = NULL;
VALA_EXTERN gchar* text_go_online_label;
VALA_EXTERN gchar* text_go_offline_label;
VALA_EXTERN gchar* text_copy_network_id_label;
VALA_EXTERN gchar* text_leave_label;
VALA_EXTERN gchar* text_delete_label;
VALA_EXTERN gchar* text_locked_label;
VALA_EXTERN gchar* text_auto_label;
VALA_EXTERN gchar* text_manual_label;
VALA_EXTERN gchar* text_approval_label;
VALA_EXTERN gchar* text_change_password_label;

VALA_EXTERN GType menus_network_menu_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MenusNetworkMenu, g_object_unref)
VALA_EXTERN GType network_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Network, g_object_unref)
VALA_EXTERN MenusNetworkMenu* menus_network_menu_new (void);
VALA_EXTERN MenusNetworkMenu* menus_network_menu_construct (GType object_type);
static void menus_network_menu_change_lock (MenusNetworkMenu* self);
VALA_EXTERN void network_set_lock (Network* self,
                       const gchar* locked);
static void menus_network_menu_change_approval (MenusNetworkMenu* self);
VALA_EXTERN void network_set_approval (Network* self,
                           const gchar* approval);
VALA_EXTERN void menus_network_menu_set_network (MenusNetworkMenu* self,
                                     Network* _network);
VALA_EXTERN void network_go_online (Network* self);
static void _network_go_online_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                gpointer self);
VALA_EXTERN void network_go_offline (Network* self);
static void _network_go_offline_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                 gpointer self);
VALA_EXTERN void network_copy_id_to_clipboard (Network* self);
static void _network_copy_id_to_clipboard_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                           gpointer self);
VALA_EXTERN void network_leave (Network* self);
static void _network_leave_gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self);
VALA_EXTERN void network_delete (Network* self);
static void _network_delete_gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static void _menus_network_menu_change_lock_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                  gpointer self);
static void _menus_network_menu_change_approval_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                      gpointer self);
VALA_EXTERN void network_change_password (Network* self);
static void _network_change_password_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                      gpointer self);
VALA_EXTERN GType status_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Status, g_object_unref)
VALA_EXTERN GType member_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Member, g_object_unref)
static void menus_network_menu_finalize (GObject * obj);
static GType menus_network_menu_get_type_once (void);

static inline gpointer
menus_network_menu_get_instance_private (MenusNetworkMenu* self)
{
	return G_STRUCT_MEMBER_P (self, MenusNetworkMenu_private_offset);
}

MenusNetworkMenu*
menus_network_menu_construct (GType object_type)
{
	MenusNetworkMenu * self = NULL;
	const gchar* _tmp0_;
	GtkMenuItem* _tmp1_;
	const gchar* _tmp2_;
	GtkMenuItem* _tmp3_;
	const gchar* _tmp4_;
	GtkMenuItem* _tmp5_;
	const gchar* _tmp6_;
	GtkMenuItem* _tmp7_;
	const gchar* _tmp8_;
	GtkMenuItem* _tmp9_;
	const gchar* _tmp10_;
	GtkCheckMenuItem* _tmp11_;
	const gchar* _tmp12_;
	GtkRadioMenuItem* _tmp13_;
	GtkRadioMenuItem* _tmp14_;
	const gchar* _tmp15_;
	GtkRadioMenuItem* _tmp16_;
	GtkMenu* _tmp17_;
	GtkMenu* _tmp18_;
	GtkRadioMenuItem* _tmp19_;
	GtkMenu* _tmp20_;
	GtkRadioMenuItem* _tmp21_;
	const gchar* _tmp22_;
	GtkMenuItem* _tmp23_;
	GtkMenuItem* _tmp24_;
	GtkMenu* _tmp25_;
	const gchar* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkSeparatorMenuItem* _tmp28_;
	GtkSeparatorMenuItem* _tmp29_;
	GtkMenuItem* _tmp30_;
	GtkMenuItem* _tmp31_;
	GtkMenuItem* _tmp32_;
	GtkMenuItem* _tmp33_;
	GtkSeparatorMenuItem* _tmp34_;
	GtkCheckMenuItem* _tmp35_;
	GtkMenuItem* _tmp36_;
	GtkMenuItem* _tmp37_;
	GtkSeparatorMenuItem* _tmp38_;
	GtkMenuItem* _tmp39_;
	self = (MenusNetworkMenu*) g_object_new (object_type, NULL);
	_tmp0_ = text_go_online_label;
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp0_);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->go_online_item);
	self->priv->go_online_item = _tmp1_;
	_tmp2_ = text_go_offline_label;
	_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp2_);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->go_offline_item);
	self->priv->go_offline_item = _tmp3_;
	_tmp4_ = text_copy_network_id_label;
	_tmp5_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp4_);
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->copy_item);
	self->priv->copy_item = _tmp5_;
	_tmp6_ = text_leave_label;
	_tmp7_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp6_);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->leave_item);
	self->priv->leave_item = _tmp7_;
	_tmp8_ = text_delete_label;
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp8_);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->delete_item);
	self->priv->delete_item = _tmp9_;
	_tmp10_ = text_locked_label;
	_tmp11_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_mnemonic (_tmp10_);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->locked_item);
	self->priv->locked_item = _tmp11_;
	_tmp12_ = text_auto_label;
	_tmp13_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_mnemonic (NULL, _tmp12_);
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->auto_item);
	self->priv->auto_item = _tmp13_;
	_tmp14_ = self->priv->auto_item;
	_tmp15_ = text_manual_label;
	_tmp16_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_mnemonic_from_widget (_tmp14_, _tmp15_);
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->manual_item);
	self->priv->manual_item = _tmp16_;
	_tmp17_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->approve_menu);
	self->priv->approve_menu = _tmp17_;
	_tmp18_ = self->priv->approve_menu;
	_tmp19_ = self->priv->auto_item;
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = self->priv->approve_menu;
	_tmp21_ = self->priv->manual_item;
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = text_approval_label;
	_tmp23_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp22_);
	g_object_ref_sink (_tmp23_);
	_g_object_unref0 (self->priv->approve_item);
	self->priv->approve_item = _tmp23_;
	_tmp24_ = self->priv->approve_item;
	_tmp25_ = self->priv->approve_menu;
	gtk_menu_item_set_submenu (_tmp24_, _tmp25_);
	_tmp26_ = text_change_password_label;
	_tmp27_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp26_);
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->password_item);
	self->priv->password_item = _tmp27_;
	_tmp28_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->separator1);
	self->priv->separator1 = _tmp28_;
	_tmp29_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp29_);
	_g_object_unref0 (self->priv->separator2);
	self->priv->separator2 = _tmp29_;
	_tmp30_ = self->priv->go_online_item;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp30_);
	_tmp31_ = self->priv->go_offline_item;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp31_);
	_tmp32_ = self->priv->leave_item;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp32_);
	_tmp33_ = self->priv->delete_item;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp33_);
	_tmp34_ = self->priv->separator1;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp34_);
	_tmp35_ = self->priv->locked_item;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp35_);
	_tmp36_ = self->priv->approve_item;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp36_);
	_tmp37_ = self->priv->password_item;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp37_);
	_tmp38_ = self->priv->separator2;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp38_);
	_tmp39_ = self->priv->copy_item;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp39_);
	gtk_widget_show_all ((GtkWidget*) self);
	return self;
}

MenusNetworkMenu*
menus_network_menu_new (void)
{
	return menus_network_menu_construct (MENUS_TYPE_NETWORK_MENU);
}

static void
menus_network_menu_change_lock (MenusNetworkMenu* self)
{
	GtkCheckMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->locked_item;
	_tmp1_ = gtk_check_menu_item_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		Network* _tmp3_;
		_tmp3_ = self->priv->network;
		network_set_lock (_tmp3_, "locked");
	} else {
		Network* _tmp4_;
		_tmp4_ = self->priv->network;
		network_set_lock (_tmp4_, "unlocked");
	}
}

static void
menus_network_menu_change_approval (MenusNetworkMenu* self)
{
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->manual_item;
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		Network* _tmp3_;
		_tmp3_ = self->priv->network;
		network_set_approval (_tmp3_, "manual");
	} else {
		Network* _tmp4_;
		_tmp4_ = self->priv->network;
		network_set_approval (_tmp4_, "auto");
	}
}

static void
_network_go_online_gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self)
{
	network_go_online ((Network*) self);
}

static void
_network_go_offline_gtk_menu_item_activate (GtkMenuItem* _sender,
                                            gpointer self)
{
	network_go_offline ((Network*) self);
}

static void
_network_copy_id_to_clipboard_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                      gpointer self)
{
	network_copy_id_to_clipboard ((Network*) self);
}

static void
_network_leave_gtk_menu_item_activate (GtkMenuItem* _sender,
                                       gpointer self)
{
	network_leave ((Network*) self);
}

static void
_network_delete_gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
	network_delete ((Network*) self);
}

static void
_menus_network_menu_change_lock_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                             gpointer self)
{
	menus_network_menu_change_lock ((MenusNetworkMenu*) self);
}

static void
_menus_network_menu_change_approval_gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                 gpointer self)
{
	menus_network_menu_change_approval ((MenusNetworkMenu*) self);
}

static void
_network_change_password_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                 gpointer self)
{
	network_change_password ((Network*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
menus_network_menu_set_network (MenusNetworkMenu* self,
                                Network* _network)
{
	Network* _tmp0_;
	Network* _tmp23_;
	Network* _tmp24_;
	Status* _tmp25_;
	Network* _tmp30_;
	gboolean _tmp42_ = FALSE;
	Network* _tmp43_;
	const gchar* _tmp44_;
	Network* _tmp49_;
	const gchar* _tmp50_;
	Network* _tmp57_;
	const gchar* _tmp58_;
	GtkMenuItem* _tmp65_;
	Network* _tmp66_;
	GtkMenuItem* _tmp67_;
	Network* _tmp68_;
	GtkMenuItem* _tmp69_;
	Network* _tmp70_;
	GtkMenuItem* _tmp71_;
	Network* _tmp72_;
	GtkMenuItem* _tmp73_;
	Network* _tmp74_;
	GtkCheckMenuItem* _tmp75_;
	GtkRadioMenuItem* _tmp76_;
	GtkMenuItem* _tmp77_;
	Network* _tmp78_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_network != NULL);
	_tmp0_ = self->priv->network;
	if (_tmp0_ != NULL) {
		GtkMenuItem* _tmp1_;
		Network* _tmp2_;
		guint _tmp3_;
		GtkMenuItem* _tmp4_;
		Network* _tmp5_;
		guint _tmp6_;
		GtkMenuItem* _tmp7_;
		Network* _tmp8_;
		guint _tmp9_;
		GtkMenuItem* _tmp10_;
		Network* _tmp11_;
		guint _tmp12_;
		GtkMenuItem* _tmp13_;
		Network* _tmp14_;
		guint _tmp15_;
		GtkCheckMenuItem* _tmp16_;
		guint _tmp17_;
		GtkRadioMenuItem* _tmp18_;
		guint _tmp19_;
		GtkMenuItem* _tmp20_;
		Network* _tmp21_;
		guint _tmp22_;
		_tmp1_ = self->priv->go_online_item;
		_tmp2_ = self->priv->network;
		g_signal_parse_name ("activate", gtk_menu_item_get_type (), &_tmp3_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _network_go_online_gtk_menu_item_activate, _tmp2_);
		_tmp4_ = self->priv->go_offline_item;
		_tmp5_ = self->priv->network;
		g_signal_parse_name ("activate", gtk_menu_item_get_type (), &_tmp6_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _network_go_offline_gtk_menu_item_activate, _tmp5_);
		_tmp7_ = self->priv->copy_item;
		_tmp8_ = self->priv->network;
		g_signal_parse_name ("activate", gtk_menu_item_get_type (), &_tmp9_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _network_copy_id_to_clipboard_gtk_menu_item_activate, _tmp8_);
		_tmp10_ = self->priv->leave_item;
		_tmp11_ = self->priv->network;
		g_signal_parse_name ("activate", gtk_menu_item_get_type (), &_tmp12_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _network_leave_gtk_menu_item_activate, _tmp11_);
		_tmp13_ = self->priv->delete_item;
		_tmp14_ = self->priv->network;
		g_signal_parse_name ("activate", gtk_menu_item_get_type (), &_tmp15_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp13_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _network_delete_gtk_menu_item_activate, _tmp14_);
		_tmp16_ = self->priv->locked_item;
		g_signal_parse_name ("toggled", gtk_check_menu_item_get_type (), &_tmp17_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _menus_network_menu_change_lock_gtk_check_menu_item_toggled, self);
		_tmp18_ = self->priv->auto_item;
		g_signal_parse_name ("toggled", gtk_check_menu_item_get_type (), &_tmp19_, NULL, FALSE);
		g_signal_handlers_disconnect_matched ((GtkCheckMenuItem*) _tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _menus_network_menu_change_approval_gtk_check_menu_item_toggled, self);
		_tmp20_ = self->priv->password_item;
		_tmp21_ = self->priv->network;
		g_signal_parse_name ("activate", gtk_menu_item_get_type (), &_tmp22_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp20_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp22_, 0, NULL, (GCallback) _network_change_password_gtk_menu_item_activate, _tmp21_);
	}
	_tmp23_ = _g_object_ref0 (_network);
	_g_object_unref0 (self->priv->network);
	self->priv->network = _tmp23_;
	_tmp24_ = self->priv->network;
	_tmp25_ = _tmp24_->status;
	if (_tmp25_->status_int == 0) {
		GtkMenuItem* _tmp26_;
		GtkMenuItem* _tmp27_;
		_tmp26_ = self->priv->go_online_item;
		gtk_widget_set_visible ((GtkWidget*) _tmp26_, TRUE);
		_tmp27_ = self->priv->go_offline_item;
		gtk_widget_set_visible ((GtkWidget*) _tmp27_, FALSE);
	} else {
		GtkMenuItem* _tmp28_;
		GtkMenuItem* _tmp29_;
		_tmp28_ = self->priv->go_online_item;
		gtk_widget_set_visible ((GtkWidget*) _tmp28_, FALSE);
		_tmp29_ = self->priv->go_offline_item;
		gtk_widget_set_visible ((GtkWidget*) _tmp29_, TRUE);
	}
	_tmp30_ = self->priv->network;
	if (_tmp30_->is_owner == -1) {
		GtkMenuItem* _tmp31_;
		GtkMenuItem* _tmp32_;
		GtkMenuItem* _tmp33_;
		_tmp31_ = self->priv->leave_item;
		gtk_widget_set_visible ((GtkWidget*) _tmp31_, FALSE);
		_tmp32_ = self->priv->delete_item;
		gtk_widget_set_visible ((GtkWidget*) _tmp32_, FALSE);
		_tmp33_ = self->priv->password_item;
		gtk_widget_set_visible ((GtkWidget*) _tmp33_, FALSE);
	} else {
		Network* _tmp34_;
		_tmp34_ = self->priv->network;
		if (_tmp34_->is_owner == 1) {
			GtkMenuItem* _tmp35_;
			GtkMenuItem* _tmp36_;
			GtkMenuItem* _tmp37_;
			_tmp35_ = self->priv->leave_item;
			gtk_widget_set_visible ((GtkWidget*) _tmp35_, FALSE);
			_tmp36_ = self->priv->delete_item;
			gtk_widget_set_visible ((GtkWidget*) _tmp36_, TRUE);
			_tmp37_ = self->priv->password_item;
			gtk_widget_set_visible ((GtkWidget*) _tmp37_, TRUE);
		} else {
			Network* _tmp38_;
			_tmp38_ = self->priv->network;
			if (_tmp38_->is_owner == 0) {
				GtkMenuItem* _tmp39_;
				GtkMenuItem* _tmp40_;
				GtkMenuItem* _tmp41_;
				_tmp39_ = self->priv->leave_item;
				gtk_widget_set_visible ((GtkWidget*) _tmp39_, TRUE);
				_tmp40_ = self->priv->delete_item;
				gtk_widget_set_visible ((GtkWidget*) _tmp40_, FALSE);
				_tmp41_ = self->priv->password_item;
				gtk_widget_set_visible ((GtkWidget*) _tmp41_, FALSE);
			}
		}
	}
	_tmp43_ = self->priv->network;
	_tmp44_ = _tmp43_->lock_state;
	if (g_strcmp0 (_tmp44_, "") != 0) {
		_tmp42_ = TRUE;
	} else {
		Network* _tmp45_;
		const gchar* _tmp46_;
		_tmp45_ = self->priv->network;
		_tmp46_ = _tmp45_->approve;
		_tmp42_ = g_strcmp0 (_tmp46_, "") != 0;
	}
	if (_tmp42_) {
		GtkSeparatorMenuItem* _tmp47_;
		_tmp47_ = self->priv->separator2;
		gtk_widget_set_visible ((GtkWidget*) _tmp47_, TRUE);
	} else {
		GtkSeparatorMenuItem* _tmp48_;
		_tmp48_ = self->priv->separator2;
		gtk_widget_set_visible ((GtkWidget*) _tmp48_, FALSE);
	}
	_tmp49_ = self->priv->network;
	_tmp50_ = _tmp49_->lock_state;
	if (g_strcmp0 (_tmp50_, "") != 0) {
		GtkCheckMenuItem* _tmp51_;
		Network* _tmp52_;
		const gchar* _tmp53_;
		_tmp51_ = self->priv->locked_item;
		gtk_widget_set_visible ((GtkWidget*) _tmp51_, TRUE);
		_tmp52_ = self->priv->network;
		_tmp53_ = _tmp52_->lock_state;
		if (g_strcmp0 (_tmp53_, "locked") == 0) {
			GtkCheckMenuItem* _tmp54_;
			_tmp54_ = self->priv->locked_item;
			gtk_check_menu_item_set_active (_tmp54_, TRUE);
		} else {
			GtkCheckMenuItem* _tmp55_;
			_tmp55_ = self->priv->locked_item;
			gtk_check_menu_item_set_active (_tmp55_, FALSE);
		}
	} else {
		GtkCheckMenuItem* _tmp56_;
		_tmp56_ = self->priv->locked_item;
		gtk_widget_set_visible ((GtkWidget*) _tmp56_, FALSE);
	}
	_tmp57_ = self->priv->network;
	_tmp58_ = _tmp57_->approve;
	if (g_strcmp0 (_tmp58_, "") != 0) {
		GtkMenuItem* _tmp59_;
		Network* _tmp60_;
		const gchar* _tmp61_;
		_tmp59_ = self->priv->approve_item;
		gtk_widget_set_visible ((GtkWidget*) _tmp59_, TRUE);
		_tmp60_ = self->priv->network;
		_tmp61_ = _tmp60_->approve;
		if (g_strcmp0 (_tmp61_, "manual") == 0) {
			GtkRadioMenuItem* _tmp62_;
			_tmp62_ = self->priv->manual_item;
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp62_, TRUE);
		} else {
			GtkRadioMenuItem* _tmp63_;
			_tmp63_ = self->priv->auto_item;
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp63_, TRUE);
		}
	} else {
		GtkMenuItem* _tmp64_;
		_tmp64_ = self->priv->approve_item;
		gtk_widget_set_visible ((GtkWidget*) _tmp64_, FALSE);
	}
	_tmp65_ = self->priv->go_online_item;
	_tmp66_ = self->priv->network;
	g_signal_connect_object (_tmp65_, "activate", (GCallback) _network_go_online_gtk_menu_item_activate, _tmp66_, 0);
	_tmp67_ = self->priv->go_offline_item;
	_tmp68_ = self->priv->network;
	g_signal_connect_object (_tmp67_, "activate", (GCallback) _network_go_offline_gtk_menu_item_activate, _tmp68_, 0);
	_tmp69_ = self->priv->copy_item;
	_tmp70_ = self->priv->network;
	g_signal_connect_object (_tmp69_, "activate", (GCallback) _network_copy_id_to_clipboard_gtk_menu_item_activate, _tmp70_, 0);
	_tmp71_ = self->priv->leave_item;
	_tmp72_ = self->priv->network;
	g_signal_connect_object (_tmp71_, "activate", (GCallback) _network_leave_gtk_menu_item_activate, _tmp72_, 0);
	_tmp73_ = self->priv->delete_item;
	_tmp74_ = self->priv->network;
	g_signal_connect_object (_tmp73_, "activate", (GCallback) _network_delete_gtk_menu_item_activate, _tmp74_, 0);
	_tmp75_ = self->priv->locked_item;
	g_signal_connect_object (_tmp75_, "toggled", (GCallback) _menus_network_menu_change_lock_gtk_check_menu_item_toggled, self, 0);
	_tmp76_ = self->priv->auto_item;
	g_signal_connect_object ((GtkCheckMenuItem*) _tmp76_, "toggled", (GCallback) _menus_network_menu_change_approval_gtk_check_menu_item_toggled, self, 0);
	_tmp77_ = self->priv->password_item;
	_tmp78_ = self->priv->network;
	g_signal_connect_object (_tmp77_, "activate", (GCallback) _network_change_password_gtk_menu_item_activate, _tmp78_, 0);
}

static void
menus_network_menu_class_init (MenusNetworkMenuClass * klass,
                               gpointer klass_data)
{
	menus_network_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MenusNetworkMenu_private_offset);
	G_OBJECT_CLASS (klass)->finalize = menus_network_menu_finalize;
}

static void
menus_network_menu_instance_init (MenusNetworkMenu * self,
                                  gpointer klass)
{
	self->priv = menus_network_menu_get_instance_private (self);
}

static void
menus_network_menu_finalize (GObject * obj)
{
	MenusNetworkMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MENUS_TYPE_NETWORK_MENU, MenusNetworkMenu);
	_g_object_unref0 (self->priv->network);
	_g_object_unref0 (self->priv->go_online_item);
	_g_object_unref0 (self->priv->go_offline_item);
	_g_object_unref0 (self->priv->leave_item);
	_g_object_unref0 (self->priv->delete_item);
	_g_object_unref0 (self->priv->separator1);
	_g_object_unref0 (self->priv->locked_item);
	_g_object_unref0 (self->priv->approve_item);
	_g_object_unref0 (self->priv->password_item);
	_g_object_unref0 (self->priv->approve_menu);
	_g_object_unref0 (self->priv->auto_item);
	_g_object_unref0 (self->priv->manual_item);
	_g_object_unref0 (self->priv->separator2);
	_g_object_unref0 (self->priv->copy_item);
	G_OBJECT_CLASS (menus_network_menu_parent_class)->finalize (obj);
}

static GType
menus_network_menu_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MenusNetworkMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) menus_network_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MenusNetworkMenu), 0, (GInstanceInitFunc) menus_network_menu_instance_init, NULL };
	GType menus_network_menu_type_id;
	menus_network_menu_type_id = g_type_register_static (gtk_menu_get_type (), "MenusNetworkMenu", &g_define_type_info, 0);
	MenusNetworkMenu_private_offset = g_type_add_instance_private (menus_network_menu_type_id, sizeof (MenusNetworkMenuPrivate));
	return menus_network_menu_type_id;
}

GType
menus_network_menu_get_type (void)
{
	static volatile gsize menus_network_menu_type_id__volatile = 0;
	if (g_once_init_enter (&menus_network_menu_type_id__volatile)) {
		GType menus_network_menu_type_id;
		menus_network_menu_type_id = menus_network_menu_get_type_once ();
		g_once_init_leave (&menus_network_menu_type_id__volatile, menus_network_menu_type_id);
	}
	return menus_network_menu_type_id__volatile;
}

