/* session.c generated by valac 0.54.6, the Vala compiler
 * generated from session.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2020 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_APP_SESSION (app_session_get_type ())
#define APP_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_SESSION, AppSession))
#define APP_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_SESSION, AppSessionClass))
#define IS_APP_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_SESSION))
#define IS_APP_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_SESSION))
#define APP_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_SESSION, AppSessionClass))

typedef struct _AppSession AppSession;
typedef struct _AppSessionClass AppSessionClass;
typedef struct _AppSessionPrivate AppSessionPrivate;
enum  {
	APP_SESSION_0_PROPERTY,
	APP_SESSION_NUM_PROPERTIES
};
static GParamSpec* app_session_properties[APP_SESSION_NUM_PROPERTIES];

#define TYPE_HAGUICHI_WINDOW (haguichi_window_get_type ())
#define HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HAGUICHI_WINDOW, HaguichiWindow))
#define HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HAGUICHI_WINDOW, HaguichiWindowClass))
#define IS_HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HAGUICHI_WINDOW))
#define IS_HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HAGUICHI_WINDOW))
#define HAGUICHI_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HAGUICHI_WINDOW, HaguichiWindowClass))

typedef struct _HaguichiWindow HaguichiWindow;
typedef struct _HaguichiWindowClass HaguichiWindowClass;
typedef struct _HaguichiWindowPrivate HaguichiWindowPrivate;

#define TYPE_NETWORK_VIEW (network_view_get_type ())
#define NETWORK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NETWORK_VIEW, NetworkView))
#define NETWORK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NETWORK_VIEW, NetworkViewClass))
#define IS_NETWORK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NETWORK_VIEW))
#define IS_NETWORK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NETWORK_VIEW))
#define NETWORK_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NETWORK_VIEW, NetworkViewClass))

typedef struct _NetworkView NetworkView;
typedef struct _NetworkViewClass NetworkViewClass;
enum  {
	APP_SESSION_MODE_CHANGED_SIGNAL,
	APP_SESSION_MODALITY_CHANGED_SIGNAL,
	APP_SESSION_VISIBILITY_CHANGED_SIGNAL,
	APP_SESSION_QUITTED_SIGNAL,
	APP_SESSION_NUM_SIGNALS
};
static guint app_session_signals[APP_SESSION_NUM_SIGNALS] = {0};
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AppSession {
	GObject parent_instance;
	AppSessionPrivate * priv;
};

struct _AppSessionClass {
	GObjectClass parent_class;
};

struct _HaguichiWindow {
	GtkApplicationWindow parent_instance;
	HaguichiWindowPrivate * priv;
	gchar* mode;
	GtkPaned* content_box;
	NetworkView* network_view;
};

struct _HaguichiWindowClass {
	GtkApplicationWindowClass parent_class;
};

static gpointer app_session_parent_class = NULL;
VALA_EXTERN HaguichiWindow* haguichi_window;
VALA_EXTERN GObject* haguichi_modal_dialog;

VALA_EXTERN GType app_session_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppSession, g_object_unref)
VALA_EXTERN guint app_session_register_object (void* object,
                                   GDBusConnection* connection,
                                   const gchar* path,
                                   GError** error);
VALA_EXTERN void app_session_show (AppSession* self,
                       GError** error);
VALA_EXTERN GType haguichi_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiWindow, g_object_unref)
VALA_EXTERN void app_session_hide (AppSession* self,
                       GError** error);
VALA_EXTERN void app_session_start_hamachi (AppSession* self,
                                GError** error);
VALA_EXTERN void global_events_start_hamachi (void);
VALA_EXTERN void app_session_stop_hamachi (AppSession* self,
                               GError** error);
VALA_EXTERN void global_events_stop_hamachi (void);
VALA_EXTERN void app_session_change_nick (AppSession* self,
                              GError** error);
VALA_EXTERN void global_events_change_nick (void);
VALA_EXTERN void app_session_join_network (AppSession* self,
                               GError** error);
VALA_EXTERN void global_events_join_network (void);
VALA_EXTERN void app_session_create_network (AppSession* self,
                                 GError** error);
VALA_EXTERN void global_events_create_network (void);
VALA_EXTERN void app_session_information (AppSession* self,
                              GError** error);
VALA_EXTERN void global_events_information (void);
VALA_EXTERN void app_session_preferences (AppSession* self,
                              GError** error);
VALA_EXTERN void global_events_preferences (void);
VALA_EXTERN void app_session_about (AppSession* self,
                        GError** error);
VALA_EXTERN void global_events_about (void);
VALA_EXTERN void app_session_quit_app (AppSession* self,
                           GError** error);
VALA_EXTERN void global_events_quit_app (void);
VALA_EXTERN gchar* app_session_get_mode (AppSession* self,
                             GError** error);
VALA_EXTERN GType network_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NetworkView, g_object_unref)
VALA_EXTERN gboolean app_session_get_modality (AppSession* self,
                                   GError** error);
VALA_EXTERN gboolean app_session_get_visibility (AppSession* self,
                                     GError** error);
VALA_EXTERN AppSession* app_session_new (void);
VALA_EXTERN AppSession* app_session_construct (GType object_type);
static GType app_session_get_type_once (void);
static void _dbus_app_session_show (AppSession* self,
                             GVariant* _parameters_,
                             GDBusMethodInvocation* invocation);
static void _dbus_app_session_hide (AppSession* self,
                             GVariant* _parameters_,
                             GDBusMethodInvocation* invocation);
static void _dbus_app_session_start_hamachi (AppSession* self,
                                      GVariant* _parameters_,
                                      GDBusMethodInvocation* invocation);
static void _dbus_app_session_stop_hamachi (AppSession* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation);
static void _dbus_app_session_change_nick (AppSession* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation);
static void _dbus_app_session_join_network (AppSession* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation);
static void _dbus_app_session_create_network (AppSession* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation);
static void _dbus_app_session_information (AppSession* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation);
static void _dbus_app_session_preferences (AppSession* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation);
static void _dbus_app_session_about (AppSession* self,
                              GVariant* _parameters_,
                              GDBusMethodInvocation* invocation);
static void _dbus_app_session_quit_app (AppSession* self,
                                 GVariant* _parameters_,
                                 GDBusMethodInvocation* invocation);
static void _dbus_app_session_get_mode (AppSession* self,
                                 GVariant* _parameters_,
                                 GDBusMethodInvocation* invocation);
static void _dbus_app_session_get_modality (AppSession* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation);
static void _dbus_app_session_get_visibility (AppSession* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation);
static void app_session_dbus_interface_method_call (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* method_name,
                                             GVariant* parameters,
                                             GDBusMethodInvocation* invocation,
                                             gpointer user_data);
static GVariant* app_session_dbus_interface_get_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GError** error,
                                                   gpointer user_data);
static gboolean app_session_dbus_interface_set_property (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* property_name,
                                                  GVariant* value,
                                                  GError** error,
                                                  gpointer user_data);
static void _dbus_app_session_mode_changed (GObject* _sender,
                                     const gchar* mode,
                                     gpointer* _data);
static void _dbus_app_session_modality_changed (GObject* _sender,
                                         gboolean modal,
                                         gpointer* _data);
static void _dbus_app_session_visibility_changed (GObject* _sender,
                                           gboolean visible,
                                           gpointer* _data);
static void _dbus_app_session_quitted (GObject* _sender,
                                gpointer* _data);
static void _app_session_unregister_object (gpointer user_data);

static const GDBusArgInfo * const _app_session_dbus_arg_info_show_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_show_out[] = {NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_show = {-1, "Show", (GDBusArgInfo **) (&_app_session_dbus_arg_info_show_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_show_out), NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_hide_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_hide_out[] = {NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_hide = {-1, "Hide", (GDBusArgInfo **) (&_app_session_dbus_arg_info_hide_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_hide_out), NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_start_hamachi_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_start_hamachi_out[] = {NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_start_hamachi = {-1, "StartHamachi", (GDBusArgInfo **) (&_app_session_dbus_arg_info_start_hamachi_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_start_hamachi_out), NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_stop_hamachi_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_stop_hamachi_out[] = {NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_stop_hamachi = {-1, "StopHamachi", (GDBusArgInfo **) (&_app_session_dbus_arg_info_stop_hamachi_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_stop_hamachi_out), NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_change_nick_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_change_nick_out[] = {NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_change_nick = {-1, "ChangeNick", (GDBusArgInfo **) (&_app_session_dbus_arg_info_change_nick_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_change_nick_out), NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_join_network_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_join_network_out[] = {NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_join_network = {-1, "JoinNetwork", (GDBusArgInfo **) (&_app_session_dbus_arg_info_join_network_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_join_network_out), NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_create_network_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_create_network_out[] = {NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_create_network = {-1, "CreateNetwork", (GDBusArgInfo **) (&_app_session_dbus_arg_info_create_network_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_create_network_out), NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_information_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_information_out[] = {NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_information = {-1, "Information", (GDBusArgInfo **) (&_app_session_dbus_arg_info_information_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_information_out), NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_preferences_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_preferences_out[] = {NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_preferences = {-1, "Preferences", (GDBusArgInfo **) (&_app_session_dbus_arg_info_preferences_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_preferences_out), NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_about_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_about_out[] = {NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_about = {-1, "About", (GDBusArgInfo **) (&_app_session_dbus_arg_info_about_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_about_out), NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_quit_app_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_quit_app_out[] = {NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_quit_app = {-1, "QuitApp", (GDBusArgInfo **) (&_app_session_dbus_arg_info_quit_app_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_quit_app_out), NULL};
static const GDBusArgInfo _app_session_dbus_arg_info_get_mode_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_get_mode_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_get_mode_out[] = {&_app_session_dbus_arg_info_get_mode_result, NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_get_mode = {-1, "GetMode", (GDBusArgInfo **) (&_app_session_dbus_arg_info_get_mode_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_get_mode_out), NULL};
static const GDBusArgInfo _app_session_dbus_arg_info_get_modality_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_get_modality_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_get_modality_out[] = {&_app_session_dbus_arg_info_get_modality_result, NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_get_modality = {-1, "GetModality", (GDBusArgInfo **) (&_app_session_dbus_arg_info_get_modality_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_get_modality_out), NULL};
static const GDBusArgInfo _app_session_dbus_arg_info_get_visibility_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_get_visibility_in[] = {NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_get_visibility_out[] = {&_app_session_dbus_arg_info_get_visibility_result, NULL};
static const GDBusMethodInfo _app_session_dbus_method_info_get_visibility = {-1, "GetVisibility", (GDBusArgInfo **) (&_app_session_dbus_arg_info_get_visibility_in), (GDBusArgInfo **) (&_app_session_dbus_arg_info_get_visibility_out), NULL};
static const GDBusMethodInfo * const _app_session_dbus_method_info[] = {&_app_session_dbus_method_info_show, &_app_session_dbus_method_info_hide, &_app_session_dbus_method_info_start_hamachi, &_app_session_dbus_method_info_stop_hamachi, &_app_session_dbus_method_info_change_nick, &_app_session_dbus_method_info_join_network, &_app_session_dbus_method_info_create_network, &_app_session_dbus_method_info_information, &_app_session_dbus_method_info_preferences, &_app_session_dbus_method_info_about, &_app_session_dbus_method_info_quit_app, &_app_session_dbus_method_info_get_mode, &_app_session_dbus_method_info_get_modality, &_app_session_dbus_method_info_get_visibility, NULL};
static const GDBusArgInfo _app_session_dbus_arg_info_mode_changed_mode = {-1, "mode", "s", NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_mode_changed[] = {&_app_session_dbus_arg_info_mode_changed_mode, NULL};
static const GDBusSignalInfo _app_session_dbus_signal_info_mode_changed = {-1, "ModeChanged", (GDBusArgInfo **) (&_app_session_dbus_arg_info_mode_changed), NULL};
static const GDBusArgInfo _app_session_dbus_arg_info_modality_changed_modal = {-1, "modal", "b", NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_modality_changed[] = {&_app_session_dbus_arg_info_modality_changed_modal, NULL};
static const GDBusSignalInfo _app_session_dbus_signal_info_modality_changed = {-1, "ModalityChanged", (GDBusArgInfo **) (&_app_session_dbus_arg_info_modality_changed), NULL};
static const GDBusArgInfo _app_session_dbus_arg_info_visibility_changed_visible = {-1, "visible", "b", NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_visibility_changed[] = {&_app_session_dbus_arg_info_visibility_changed_visible, NULL};
static const GDBusSignalInfo _app_session_dbus_signal_info_visibility_changed = {-1, "VisibilityChanged", (GDBusArgInfo **) (&_app_session_dbus_arg_info_visibility_changed), NULL};
static const GDBusArgInfo * const _app_session_dbus_arg_info_quitted[] = {NULL};
static const GDBusSignalInfo _app_session_dbus_signal_info_quitted = {-1, "Quitted", (GDBusArgInfo **) (&_app_session_dbus_arg_info_quitted), NULL};
static const GDBusSignalInfo * const _app_session_dbus_signal_info[] = {&_app_session_dbus_signal_info_mode_changed, &_app_session_dbus_signal_info_modality_changed, &_app_session_dbus_signal_info_visibility_changed, &_app_session_dbus_signal_info_quitted, NULL};
static const GDBusPropertyInfo * const _app_session_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _app_session_dbus_interface_info = {-1, "com.github.ztefn.haguichi", (GDBusMethodInfo **) (&_app_session_dbus_method_info), (GDBusSignalInfo **) (&_app_session_dbus_signal_info), (GDBusPropertyInfo **) (&_app_session_dbus_property_info), NULL};
static const GDBusInterfaceVTable _app_session_dbus_interface_vtable = {app_session_dbus_interface_method_call, app_session_dbus_interface_get_property, app_session_dbus_interface_set_property};

void
app_session_show (AppSession* self,
                  GError** error)
{
	HaguichiWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = haguichi_window;
	gtk_window_present ((GtkWindow*) _tmp0_);
}

void
app_session_hide (AppSession* self,
                  GError** error)
{
	HaguichiWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = haguichi_window;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
}

void
app_session_start_hamachi (AppSession* self,
                           GError** error)
{
	g_return_if_fail (self != NULL);
	global_events_start_hamachi ();
}

void
app_session_stop_hamachi (AppSession* self,
                          GError** error)
{
	g_return_if_fail (self != NULL);
	global_events_stop_hamachi ();
}

void
app_session_change_nick (AppSession* self,
                         GError** error)
{
	HaguichiWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = haguichi_window;
	gtk_window_present ((GtkWindow*) _tmp0_);
	global_events_change_nick ();
}

void
app_session_join_network (AppSession* self,
                          GError** error)
{
	HaguichiWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = haguichi_window;
	gtk_window_present ((GtkWindow*) _tmp0_);
	global_events_join_network ();
}

void
app_session_create_network (AppSession* self,
                            GError** error)
{
	HaguichiWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = haguichi_window;
	gtk_window_present ((GtkWindow*) _tmp0_);
	global_events_create_network ();
}

void
app_session_information (AppSession* self,
                         GError** error)
{
	HaguichiWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = haguichi_window;
	gtk_window_present ((GtkWindow*) _tmp0_);
	global_events_information ();
}

void
app_session_preferences (AppSession* self,
                         GError** error)
{
	g_return_if_fail (self != NULL);
	global_events_preferences ();
}

void
app_session_about (AppSession* self,
                   GError** error)
{
	g_return_if_fail (self != NULL);
	global_events_about ();
}

void
app_session_quit_app (AppSession* self,
                      GError** error)
{
	g_return_if_fail (self != NULL);
	global_events_quit_app ();
}

gchar*
app_session_get_mode (AppSession* self,
                      GError** error)
{
	HaguichiWindow* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = haguichi_window;
	_tmp1_ = _tmp0_->mode;
	_tmp2_ = g_strdup (_tmp1_);
	result = _tmp2_;
	return result;
}

gboolean
app_session_get_modality (AppSession* self,
                          GError** error)
{
	GObject* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = haguichi_modal_dialog;
	result = _tmp0_ != NULL;
	return result;
}

gboolean
app_session_get_visibility (AppSession* self,
                            GError** error)
{
	HaguichiWindow* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = haguichi_window;
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

AppSession*
app_session_construct (GType object_type)
{
	AppSession * self = NULL;
	self = (AppSession*) g_object_new (object_type, NULL);
	return self;
}

AppSession*
app_session_new (void)
{
	return app_session_construct (TYPE_APP_SESSION);
}

static void
app_session_class_init (AppSessionClass * klass,
                        gpointer klass_data)
{
	app_session_parent_class = g_type_class_peek_parent (klass);
	app_session_signals[APP_SESSION_MODE_CHANGED_SIGNAL] = g_signal_new ("mode-changed", TYPE_APP_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	app_session_signals[APP_SESSION_MODALITY_CHANGED_SIGNAL] = g_signal_new ("modality-changed", TYPE_APP_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	app_session_signals[APP_SESSION_VISIBILITY_CHANGED_SIGNAL] = g_signal_new ("visibility-changed", TYPE_APP_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	app_session_signals[APP_SESSION_QUITTED_SIGNAL] = g_signal_new ("quitted", TYPE_APP_SESSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
app_session_instance_init (AppSession * self,
                           gpointer klass)
{
}

static GType
app_session_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AppSessionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_session_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppSession), 0, (GInstanceInitFunc) app_session_instance_init, NULL };
	GType app_session_type_id;
	app_session_type_id = g_type_register_static (G_TYPE_OBJECT, "AppSession", &g_define_type_info, 0);
	g_type_set_qdata (app_session_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) app_session_register_object);
	return app_session_type_id;
}

GType
app_session_get_type (void)
{
	static volatile gsize app_session_type_id__volatile = 0;
	if (g_once_init_enter (&app_session_type_id__volatile)) {
		GType app_session_type_id;
		app_session_type_id = app_session_get_type_once ();
		g_once_init_leave (&app_session_type_id__volatile, app_session_type_id);
	}
	return app_session_type_id__volatile;
}

static void
_dbus_app_session_show (AppSession* self,
                        GVariant* _parameters_,
                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	app_session_show (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_hide (AppSession* self,
                        GVariant* _parameters_,
                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	app_session_hide (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_start_hamachi (AppSession* self,
                                 GVariant* _parameters_,
                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	app_session_start_hamachi (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_stop_hamachi (AppSession* self,
                                GVariant* _parameters_,
                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	app_session_stop_hamachi (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_change_nick (AppSession* self,
                               GVariant* _parameters_,
                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	app_session_change_nick (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_join_network (AppSession* self,
                                GVariant* _parameters_,
                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	app_session_join_network (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_create_network (AppSession* self,
                                  GVariant* _parameters_,
                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	app_session_create_network (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_information (AppSession* self,
                               GVariant* _parameters_,
                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	app_session_information (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_preferences (AppSession* self,
                               GVariant* _parameters_,
                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	app_session_preferences (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_about (AppSession* self,
                         GVariant* _parameters_,
                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	app_session_about (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_quit_app (AppSession* self,
                            GVariant* _parameters_,
                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	app_session_quit_app (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_get_mode (AppSession* self,
                            GVariant* _parameters_,
                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = app_session_get_mode (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_get_modality (AppSession* self,
                                GVariant* _parameters_,
                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = app_session_get_modality (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_app_session_get_visibility (AppSession* self,
                                  GVariant* _parameters_,
                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = app_session_get_visibility (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
app_session_dbus_interface_method_call (GDBusConnection* connection,
                                        const gchar* sender,
                                        const gchar* object_path,
                                        const gchar* interface_name,
                                        const gchar* method_name,
                                        GVariant* parameters,
                                        GDBusMethodInvocation* invocation,
                                        gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Show") == 0) {
		_dbus_app_session_show (object, parameters, invocation);
	} else if (strcmp (method_name, "Hide") == 0) {
		_dbus_app_session_hide (object, parameters, invocation);
	} else if (strcmp (method_name, "StartHamachi") == 0) {
		_dbus_app_session_start_hamachi (object, parameters, invocation);
	} else if (strcmp (method_name, "StopHamachi") == 0) {
		_dbus_app_session_stop_hamachi (object, parameters, invocation);
	} else if (strcmp (method_name, "ChangeNick") == 0) {
		_dbus_app_session_change_nick (object, parameters, invocation);
	} else if (strcmp (method_name, "JoinNetwork") == 0) {
		_dbus_app_session_join_network (object, parameters, invocation);
	} else if (strcmp (method_name, "CreateNetwork") == 0) {
		_dbus_app_session_create_network (object, parameters, invocation);
	} else if (strcmp (method_name, "Information") == 0) {
		_dbus_app_session_information (object, parameters, invocation);
	} else if (strcmp (method_name, "Preferences") == 0) {
		_dbus_app_session_preferences (object, parameters, invocation);
	} else if (strcmp (method_name, "About") == 0) {
		_dbus_app_session_about (object, parameters, invocation);
	} else if (strcmp (method_name, "QuitApp") == 0) {
		_dbus_app_session_quit_app (object, parameters, invocation);
	} else if (strcmp (method_name, "GetMode") == 0) {
		_dbus_app_session_get_mode (object, parameters, invocation);
	} else if (strcmp (method_name, "GetModality") == 0) {
		_dbus_app_session_get_modality (object, parameters, invocation);
	} else if (strcmp (method_name, "GetVisibility") == 0) {
		_dbus_app_session_get_visibility (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
app_session_dbus_interface_get_property (GDBusConnection* connection,
                                         const gchar* sender,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* property_name,
                                         GError** error,
                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
app_session_dbus_interface_set_property (GDBusConnection* connection,
                                         const gchar* sender,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* property_name,
                                         GVariant* value,
                                         GError** error,
                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_app_session_mode_changed (GObject* _sender,
                                const gchar* mode,
                                gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (mode));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.github.ztefn.haguichi", "ModeChanged", _arguments, NULL);
}

static void
_dbus_app_session_modality_changed (GObject* _sender,
                                    gboolean modal,
                                    gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (modal));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.github.ztefn.haguichi", "ModalityChanged", _arguments, NULL);
}

static void
_dbus_app_session_visibility_changed (GObject* _sender,
                                      gboolean visible,
                                      gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (visible));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.github.ztefn.haguichi", "VisibilityChanged", _arguments, NULL);
}

static void
_dbus_app_session_quitted (GObject* _sender,
                           gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.github.ztefn.haguichi", "Quitted", _arguments, NULL);
}

guint
app_session_register_object (gpointer object,
                             GDBusConnection* connection,
                             const gchar* path,
                             GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_app_session_dbus_interface_info), &_app_session_dbus_interface_vtable, data, _app_session_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "mode-changed", (GCallback) _dbus_app_session_mode_changed, data);
	g_signal_connect (object, "modality-changed", (GCallback) _dbus_app_session_modality_changed, data);
	g_signal_connect (object, "visibility-changed", (GCallback) _dbus_app_session_visibility_changed, data);
	g_signal_connect (object, "quitted", (GCallback) _dbus_app_session_quitted, data);
	return result;
}

static void
_app_session_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_app_session_mode_changed, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_app_session_modality_changed, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_app_session_visibility_changed, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_app_session_quitted, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

