/* cell-renderer-node.c generated by valac 0.54.6, the Vala compiler
 * generated from cell-renderer-node.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2020 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CELL_RENDERER_NODE (cell_renderer_node_get_type ())
#define CELL_RENDERER_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CELL_RENDERER_NODE, CellRendererNode))
#define CELL_RENDERER_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CELL_RENDERER_NODE, CellRendererNodeClass))
#define IS_CELL_RENDERER_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CELL_RENDERER_NODE))
#define IS_CELL_RENDERER_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CELL_RENDERER_NODE))
#define CELL_RENDERER_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CELL_RENDERER_NODE, CellRendererNodeClass))

typedef struct _CellRendererNode CellRendererNode;
typedef struct _CellRendererNodeClass CellRendererNodeClass;
typedef struct _CellRendererNodePrivate CellRendererNodePrivate;
enum  {
	CELL_RENDERER_NODE_0_PROPERTY,
	CELL_RENDERER_NODE_NUM_PROPERTIES
};
static GParamSpec* cell_renderer_node_properties[CELL_RENDERER_NODE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CellRendererNode {
	GtkCellRendererPixbuf parent_instance;
	CellRendererNodePrivate * priv;
};

struct _CellRendererNodeClass {
	GtkCellRendererPixbufClass parent_class;
};

static gpointer cell_renderer_node_parent_class = NULL;

VALA_EXTERN GType cell_renderer_node_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CellRendererNode, g_object_unref)
static void cell_renderer_node_real_render (GtkCellRenderer* base,
                                     cairo_t* cr,
                                     GtkWidget* widget,
                                     GdkRectangle* background_area,
                                     GdkRectangle* cell_area,
                                     GtkCellRendererState flags);
VALA_EXTERN CellRendererNode* cell_renderer_node_new (void);
VALA_EXTERN CellRendererNode* cell_renderer_node_construct (GType object_type);
static GType cell_renderer_node_get_type_once (void);

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
cell_renderer_node_real_render (GtkCellRenderer* base,
                                cairo_t* cr,
                                GtkWidget* widget,
                                GdkRectangle* background_area,
                                GdkRectangle* cell_area,
                                GtkCellRendererState flags)
{
	CellRendererNode * self;
	GdkRectangle aligned_area = {0};
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_ = {0};
	gint x = 0;
	GdkRectangle _tmp2_;
	gint y = 0;
	GdkRectangle _tmp3_;
	gint width = 0;
	GdkRectangle _tmp4_;
	gint height = 0;
	GdkRectangle _tmp5_;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp6_;
	GtkStyleContext* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	self = (CellRendererNode*) base;
	g_return_if_fail (cr != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (background_area != NULL);
	g_return_if_fail (cell_area != NULL);
	_tmp0_ = *cell_area;
	gtk_cell_renderer_get_aligned_area ((GtkCellRenderer*) self, widget, flags, &_tmp0_, &_tmp1_);
	aligned_area = _tmp1_;
	_tmp2_ = aligned_area;
	x = _tmp2_.x + 4;
	_tmp3_ = aligned_area;
	y = _tmp3_.y + 4;
	_tmp4_ = aligned_area;
	width = _tmp4_.width - 7;
	_tmp5_ = aligned_area;
	height = _tmp5_.height - 7;
	_tmp6_ = gtk_widget_get_style_context (widget);
	_tmp7_ = _g_object_ref0 (_tmp6_);
	context = _tmp7_;
	gtk_style_context_add_class (context, "network-node");
	g_object_get ((GtkCellRendererPixbuf*) self, "icon-name", &_tmp8_, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = _tmp9_;
	gtk_style_context_add_class (context, _tmp10_);
	_g_free0 (_tmp10_);
	gtk_render_background (context, cr, (gdouble) x, (gdouble) y, (gdouble) width, (gdouble) height);
	_g_object_unref0 (context);
}

CellRendererNode*
cell_renderer_node_construct (GType object_type)
{
	CellRendererNode * self = NULL;
	self = (CellRendererNode*) g_object_new (object_type, NULL);
	return self;
}

CellRendererNode*
cell_renderer_node_new (void)
{
	return cell_renderer_node_construct (TYPE_CELL_RENDERER_NODE);
}

static void
cell_renderer_node_class_init (CellRendererNodeClass * klass,
                               gpointer klass_data)
{
	cell_renderer_node_parent_class = g_type_class_peek_parent (klass);
	((GtkCellRendererClass *) klass)->render = (void (*) (GtkCellRenderer*, cairo_t*, GtkWidget*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) cell_renderer_node_real_render;
}

static void
cell_renderer_node_instance_init (CellRendererNode * self,
                                  gpointer klass)
{
}

static GType
cell_renderer_node_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CellRendererNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cell_renderer_node_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CellRendererNode), 0, (GInstanceInitFunc) cell_renderer_node_instance_init, NULL };
	GType cell_renderer_node_type_id;
	cell_renderer_node_type_id = g_type_register_static (gtk_cell_renderer_pixbuf_get_type (), "CellRendererNode", &g_define_type_info, 0);
	return cell_renderer_node_type_id;
}

GType
cell_renderer_node_get_type (void)
{
	static volatile gsize cell_renderer_node_type_id__volatile = 0;
	if (g_once_init_enter (&cell_renderer_node_type_id__volatile)) {
		GType cell_renderer_node_type_id;
		cell_renderer_node_type_id = cell_renderer_node_get_type_once ();
		g_once_init_leave (&cell_renderer_node_type_id__volatile, cell_renderer_node_type_id);
	}
	return cell_renderer_node_type_id__volatile;
}

